{*******************************************************}
{                                                       }
{   Turbo Pascal 7.0                                    }
{   FreePacal                                           }
{   Delphi 4                                            }
{       Extended visual components                      }
{                                                       }
{   Copyright (c) 1995-99 by Alexs                      }
{                                                       }
{*******************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}
{$I Define.inc}
unit AboutPn;
interface
uses Objects, Views, Drivers, Clases, Register;

const
  CAboutPanel    = #6;
  DelayTicks:integer = 1000;

type
  PAboutPanel = ^TAboutPanel;
  TAboutPanel = object(TView)
    AboutString: PStringCollection;
    DeltaY:integer;
    Ticks:integer;
    Caption:PString;
    constructor Init(var Bounds: TRect; ACaption:string; AStrings: PSItem);
    constructor Load(var S:TStream);
    destructor Done;virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
    procedure Draw;virtual;
    procedure Store(var S:TStream);
  end;

const
  RAboutPanel: TStreamRec = (
     ObjType: rcAboutPanel;
     VmtLink: Ofs(TypeOf(TAboutPanel)^);
     Load:    @TAboutPanel.Load;
     Store:   @TAboutPanel.Store
  );

implementation
uses AddCntrl, Ext_Str, Ext_Type;

constructor TAboutPanel.Init(var Bounds: TRect; ACaption:string; AStrings: PSItem);
var
  I: Integer;
  P: PSItem;
begin
  inherited Init(Bounds);
  Caption:=NewStr(ACaption);
  EventMask:= evKeyDown + evCommand + evBroadcast;
  Options := Options or (ofSelectable + ofFirstClick + ofPreProcess +
    ofPostProcess + ofVersion20);
  I := 0;
  P := AStrings;
  while P <> nil do
  begin
    Inc(I);
    P := P^.Next;
  end;
  AboutString:=New(PStringCollection, Init(I,6));
  while AStrings <> nil do
  begin
    P := AStrings;
    AboutString^.AtInsert(AboutString^.Count, AStrings^.Value);
    AStrings := AStrings^.Next;
    Dispose(P);
  end;
  if not DesignTime then Hide;
  ComponentType:=ctAboutPanel;
end;

constructor TAboutPanel.Load(var S:TStream);
begin
  inherited Load(S);
  AboutString:=PStringCollection(S.Get);
  Caption:=S.ReadStr;
  if not DesignTime then Hide;
end;

destructor TAboutPanel.Done;
begin
  Dispose(AboutString, Done);
  inherited Done;
end;

function TAboutPanel.GetPalette: PPalette;
const
  P: String[Length(CAboutPanel)] = CAboutPanel;
begin
  GetPalette := @P;
end;

procedure TAboutPanel.Draw;
var
  B: TDrawBuffer;
  C: Byte;
  I,ii: Integer;
  S: String;
  P: PString;
begin
  C := GetColor(1);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, Caption^, C);
  WriteLine(0, 0, Size.X, 1, B);
  II:=Size.Y - DeltaY - 1;
  for I := 1 to Size.Y - 1 do
  begin
    MoveChar(B, ' ', C, Size.X);
    if i >= ii then
    begin
      P := AboutString^.At(i-ii);
      if P <> nil then
      begin
        S := Copy(P^, 1, Size.X);
        case S[1] of
          ^C:S:=MakeAlign(alCenter, Copy(S,2,255), Size.X);
          ^R:S:=MakeAlign(alRight, Copy(S,2,255), Size.X);
          ^L:S:=MakeAlign(alLeft, Copy(S,2,255), Size.X);
        end;
      end
      else S := '';
      MoveStr(B, S, C);
    end;
    WriteLine(0, I, Size.X, 1, B);
  end;
end;

procedure TAboutPanel.HandleEvent(var Event:TEvent);

procedure DrawNext;
begin
  if DesignTime then exit;
  if State and sfVisible = 0 then exit;
  inc(Ticks);
  if Ticks<>DelayTicks then exit;
  Ticks:=0;
  inc(DeltaY);
  if DeltaY = AboutString^.Count then
  begin
    Hide;
    DeltaY:=0;
  end;
  DrawView;
end;

begin
  inherited HandleEvent(Event);
{  if Debug then Exit;}
  case Event.What of
    evKeyDown:
      if Event.KeyCode =  kbAltI then Show
      else Exit;
    evBroadcast:
      if Event.Command = cmIdle then DrawNext
      else Exit;
  else
    exit;
  end;
  ClearEvent(Event);
end;

procedure TAboutPanel.Store(var S:TStream);
begin
  inherited Store(S);
  S.Put(AboutString);
  S.WriteStr(Caption);
end;

end.
