{************************************************}
{                                                }
{   Resourse tools                               }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}
{$I Define.inc}

unit ResTools;

interface

uses Objects, Menus, Views, Register;

const
   hcWindList           = $FF30;

type
  PProtectedStream = ^TProtectedStream;
{  TProtectedStream = object(TBufStream)}
  TProtectedStream = object(TDosStream)
    procedure Error(Code, Info: Integer); virtual;
  end;

type
  PHCStatusLine = ^THCStatusLine;
  THCStatusLine = object(TStatusLine)
    function Hint(AHelpCtx: Word): String; virtual;
  end;

const
  Target:Boolean=true;

const
{  EXEName:FNameStr='';}
  OVRName:FNameStr='';
  TVRName:FNameSTr='';

var
  ResourseFile: TResourceFile;
const
  ResourseStream: PStream = nil;
  ResourseStrings: PStringList = nil;
  HelpStrings: PStringList = nil;

procedure InitTVRFile( AName:FNameStr);
procedure DoneTVRFile;
procedure UpDateName(Item:PMenuItem; AName:PString);
procedure UpdateParam(Item:PMenuItem; AParam:PString);
function GetItem(ACommand:word):PMenuItem;
function GetItemN(AName:string; Menu:PMenu):PMenuItem;
function GetWindowNumber:byte;
function RMessageBox( StrNum: Word; Param: Pointer; Flags: Word): Word;
function RMessageBoxRect(var Rect: TRect; StrNum: Word; Param: Pointer;
  Flags: Word): Word;
function ExecDialog(const Dialog: String; Param: Pointer): Word;
function RExecDialog(Name:word; Param:Pointer):word;
function GetString(Name:integer):string;
function GetView(Name:word):Pointer;
function WaitEvent:Boolean;
procedure ShowMessage(const S:String);
procedure DisposeMenuItem(P:PMenuItem);
function Format(S:String; var P):string;
function RFormat(Name:word; var P):string;

function StdSystemMenuItemsRus(Next: PMenuItem): PMenuItem;
function StdSystemMenuItemsRusExt(Next: PMenuItem): PMenuItem;
function StdFileMenuItemsRus(Next: PMenuItem): PMenuItem;
function StdEditMenuItemsRus(Next: PMenuItem): PMenuItem;
function StdWindowMenuItemsRus(Next: PMenuItem): PMenuItem;
function StdHelpMenuItems(Next: PMenuItem): PMenuItem;

{$IFDEF VER70}
function NewStatusKeyExt(const AText:string; AKeyCode:word; ACommand:word;
          var Self:PStatusItem; ANext:PStatusItem):PStatusItem;
{$ENDIF}

{$IFNDEF DELPHI32}
const
  RHCStatusLine : TStreamRec = (
    ObjType : 100;
    VmtLink : Ofs(TypeOf(THCStatusLine)^);
    Load    : @THCStatusLine.Load;
    Store   : @THCStatusLine.Store
  );
{$ENDIF}
procedure RegisterGlobals;
implementation
uses Ext_Dos, App, MsgBox, Dialogs, Drivers, Ext_Str, ListWind, Ext_Math, Ext_Sys;

procedure InitTVRFile( AName:FNameStr);
begin
  if FileExists(AName) then
  begin
{      ResourseStream:=New(PProtectedStream, Init( AName, stOpenRead, 4096));}
      ResourseStream:=New(PProtectedStream, Init( AName, stOpenRead));
      if ResourseStream^.Status<>stOk then
      begin
         PrintStr('Error resurse file: '+IntToStr(ResourseStream^.Status)+
         '.'#13#10'Programm terminated.');
         halt(1);
      end;
  end
  else
  begin
    PrintStr('File '''+AName+''' not found.'+#13#10'Programm terminated.'#13#10);
    halt(1);
  end;
  ResourseFile.Init(ResourseStream);
  TVRName:=AName;
end;

procedure DoneTVRFile;
begin
  ResourseFile.Done;
end;

function RMessageBox(StrNum: Word; Param: Pointer; Flags: Word): Word;
begin
  RMessageBox := MessageBox(ResourseStrings^.Get(StrNum), Param, Flags);
end;

function RMessageBoxRect(var Rect: TRect; StrNum: Word; Param: Pointer;
  Flags: Word): Word;
begin
  RMessageBoxRect := MessageBoxRect(Rect, ResourseStrings^.Get(StrNum), Param,
    Flags);
end;

function DExec(const Dialog: word; Param: Pointer): Word;
begin
  DExec:=ExecDialog( ResourseStrings^.Get(Dialog),Param);
end;

function ExecDialog(const Dialog: String; Param: Pointer): Word;
begin
  ExecDialog := Application^.ExecuteDialog(PDialog(ResourseFile.Get(Dialog)),
      Param);
end;

{ TProtectedStream }

procedure TProtectedStream.Error(Code, Info: Integer);
begin
  PrintStr('Error in stream: Code = '+IntToStr(Code)+' Info = '+IntToStr(Info)+#13#10);
  Halt(1);
end;

{ THCStatusLine }

function THCStatusLine.Hint(AHelpCtx: Word) :String;
var
  S:string;
begin
  if (AHelpCtx=0) or (HelpStrings=nil) then Hint := ''
  else
  begin
    S:=HelpStrings^.Get(AHelpCtx);
    if S<>'' then Hint := S+'.'
    else Hint := '';
  end;
end;

procedure UpDateName(Item:PMenuItem; AName:PString);
begin
  if Item=nil then exit;
  DisposeStr(Item^.Name);
  Item^.Name:=AName;
end;

procedure UpdateParam(Item:PMenuItem; AParam:PString);
begin
  if Item=nil then exit;
  if Item^.Param<>nil then DisposeStr(Item^.Param);
  Item^.Param:=AParam;
end;

function GetItemN(AName:string; Menu:PMenu):PMenuItem;
procedure Find(M:PMenu);
var Item:PMenuItem;
begin
  if M=nil then exit;
  Item:=M^.Items;
  while Item<>nil do
  begin
    if Item^.Name<>nil then
    if stUpCase(Item^.Name^)=AName then
    begin
       GetItemN:=Item;
       exit;
    end
    else
      if Item^.Command=0 then Find(Item^.SubMenu);
      Item:=Item^.Next;
  end;
end;

begin
  GetItemN:=nil;
  AName:=stUpCase(AName);
  Find(Menu);
end;

function GetItem(ACommand:word):PMenuItem;
procedure Find(M:PMenu);
var Item:PMenuItem;
begin
  if M=nil then exit;
  Item:=M^.Items;
  while Item<>nil do
  begin
    if Item^.Name<>nil then
    if Item^.Command=Acommand then
    begin
       GetItem:=Item;
       exit;
    end
    else
      if Item^.Command=0 then Find(Item^.SubMenu);
      Item:=Item^.Next;
  end;
end;

begin
  GetItem:=nil;
  Find(MenuBar^.Menu);
end;

{**************** GetNumberWindow ***********************}
{ Return first free window number in application desktop}
{********************************************************}
function GetWindowNumber:byte;
var
  i:byte;

function IsSelecatble(P:PView):Boolean;
begin
  if (P^.Options and ofSelectable <> 0) and (P^.State and sfVisible <> 0) then
     IsSelecatble := PWindow(P)^.Number = i
  else IsSelecatble := false;
end;

function TestSelectable:boolean;
var Temp:PView;
begin
  TestSelectable:=true;
  with Desktop^ do
  if (Last<>Nil) Then
  begin
    Temp:=Last;
    repeat
      Temp:=Temp^.Next;
      if (Temp<>nil) and (Temp^.Options and ofSelectable <> 0) and
        (Temp^.State and sfVisible <> 0) then
        if PWindow(Temp)^.Number = i then
        begin
          TestSelectable:=false;
          exit;
        end;
    until (Temp=Last) or (Temp=nil);
  end;
end;

begin
  i:=0;
  if Desktop<>nil then
  repeat
    inc(i)
  until (TestSelectable) or (I>9);
  GetWindowNumber:=i;
end;

{************************* WhitEvent:Boolean ***************************}
{  室  ⥬   ᮡ                            }
{ 頥 true ᫨ ᮡ                            }
{***********************************************************************}
function WaitEvent:Boolean;
var
  Event:TEvent;
begin
  repeat
    GetMouseEvent(Event);
    if Event.What = evNothing then
       GetKeyEvent(Event);
  until (Event.What=evKeyDown) or (Event.What=evMouseDown);
  WaitEvent:=Event.What=evKeyDown;
end;

procedure ShowMessage(const S:String);
var
  B:TDrawBuffer;
  Color:word;
begin
  if StatusLine=nil then Exit;
  if S<>'' then
  begin
    Color:=StatusLine^.GetColor(1);
    MoveChar(B, ' ', Color, StatusLine^.Size.X);
    MoveStr(B[0], S, Color);
    StatusLine^.WriteBuf(0,0,StatusLine^.Size.X,1,B)
  end
  else
    StatusLine^.DrawView;
end;

procedure DisposeMenuItem(P:PMenuItem);
begin
   DisposeStr(P^.Name);
   if P^.Command <> 0 then DisposeStr(P^.Param) else
   DisposeMenu(P^.SubMenu);
   Dispose(P);
end;

function RExecDialog(Name:word; Param:Pointer):word;
begin
  RExecDialog:=Application^.ExecuteDialog(PDialog(ResourseFile.Get(
  ResourseStrings^.Get(Name))),Param);
end;

function GetString(Name:integer):string;
begin
  GetString:=ResourseStrings^.Get(Name);
end;

function GetView(Name:word):Pointer;
var P:PView;
begin
  P:=PView(ResourseFile.Get(GetString(Name)));
  if P<>nil then P^.DoInitialization;
  GetView:=P;
end;

function Format(S:String; var P):string;
{$IFDEF VER70}
var Result:string;
begin
  FormatStr(Result,S,P);
  Format:=Result;
end;
{$ELSE}
begin
  FormatStr(Result,S,P);
end;
{$ENDIF}

function RFormat(Name:word; var P):string;
{$IFDEF VER70}
var
  Result:string;
begin
  FormatStr(Result,GetString(Name),P);
  RFormat:=Result;
end;
{$ELSE}
begin
  FormatStr(Result,GetString(Name),P);
end;
{$ENDIF}

function StdSystemMenuItemsRus(Next: PMenuItem): PMenuItem;
begin
  StdSystemMenuItemsRus:=
      NewItem('~~', '', kbNoKey, cmCalen, hcNoContext,
      NewItem('~~', '', kbNoKey, cmCalc, hcNoContext,
      NewLine(
      NewItem('~~२஢', '', kbNoKey, cmReindex, hcNoContext,
      NewLine(
      NewItem('~~', '', kbAltX, cmQuit, hcNoContext,
  Next))))));
end;

function StdSystemMenuItemsRusExt(Next: PMenuItem): PMenuItem;
begin
  StdSystemMenuItemsRusExt:=
      NewItem('~~', '', kbNoKey, cmCalen, hcNoContext,
      NewItem('~~', '', kbNoKey, cmCalc, hcNoContext,
      NewLine(
      NewItem('~~२஢', '', kbNoKey, cmReindex, hcNoContext,
      NewLine(
      NewItem('~~樨', '', kbNoKey, cmAppOptions, hcNoContext,
      NewLine(
      NewItem('~~', '', kbAltX, cmQuit, hcNoContext,
  Next))))))));
end;

function StdFileMenuItemsRus(Next: PMenuItem): PMenuItem;
begin
  StdFileMenuItemsRus :=
    NewItem('~N~ew', '', kbNoKey, cmNew, hcNew,
    NewItem('~O~pen...', 'F3', kbF3, cmOpen, hcOpen,
    NewItem('~S~ave', 'F2', kbF2, cmSave, hcSave,
    NewItem('S~a~ve as...', '', kbNoKey, cmSaveAs, hcSaveAs,
    NewItem('Save a~l~l', '', kbNoKey, cmSaveAll, hcSaveAll,
    NewLine(
    NewItem('~C~hange dir...', '', kbNoKey, cmChangeDir, hcChangeDir,
    NewItem('~D~OS shell', '', kbNoKey, cmDosShell, hcDosShell,
    NewItem('E~x~it', 'Alt+X', kbAltX, cmQuit, hcExit,
    Next)))))))));
end;

function StdEditMenuItemsRus(Next: PMenuItem): PMenuItem;
begin
  StdEditMenuItemsRus :=
    NewItem('~U~ndo', '', kbAltBack, cmUndo, hcUndo,
    NewLine(
    NewItem('Cu~t~', 'Shift+Del', kbShiftDel, cmCut, hcCut,
    NewItem('~C~opy', 'Ctrl+Ins', kbCtrlIns, cmCopy, hcCopy,
    NewItem('~P~aste', 'Shift+Ins', kbShiftIns, cmPaste, hcPaste,
    NewItem('C~l~ear', 'Ctrl+Del', kbCtrlDel, cmClear, hcClear,
    Next))))));
end;

function StdWindowMenuItemsRus(Next: PMenuItem): PMenuItem;
begin
  StdWindowMenuItemsRus :=
      NewItem('~~९楩', '', kbNoKey, cmTile, hcTile,
      NewItem('~~᪠', '', kbNoKey, cmCascade, hcCascade,
      NewItem(' ~~', '', kbNoKey, cmCloseAll, hcCloseAll,
      NewLine(
      NewItem('~~/६饭','Ctrl+F5', kbCtrlF5, cmResize, hcReSize,
      NewItem('~~⠡', 'F5', kbF5, cmZoom, hcZoom,
      NewItem('~~饥', 'F6', kbF6, cmNext, hcNext,
      NewItem('~~ॢ饥', 'Shift+F6', kbShiftF6, cmPrev, hcPrev,
      NewItem('~~', 'Alt+F3', kbAltF3, cmClose, hcClose,
      NewLine(
      NewItem('~~᮪', 'Alt+0', kbAlt0, cmWindowList, hcWindList,
    Next)))))))))));
end;

function StdHelpMenuItems(Next: PMenuItem): PMenuItem;
begin
  StdHelpMenuItems:=
      NewItem({$IFDEF RUS}'~~⥪'{$ELSE}'~C~ontents'{$ENDIF}, 'F1', kbF1, cmHelp, hcNoContext,
      NewLine(
      NewItem({$IFDEF RUS}'~~ '{$ELSE}'~A~bout...'{$ENDIF}, '', kbNoKey, cmAbout, hcNoContext,
  Next)));
end;
{$IFDEF VER70}
function NewStatusKeyExt(const AText: String; AKeyCode: Word; ACommand: Word;
         var Self: PStatusItem; ANext: PStatusItem): PStatusItem;
begin
  New(Self);
  Self^.Text := NewStr(AText);
  Self^.KeyCode := AKeyCode;
  Self^.Command := ACommand;
  Self^.Next := ANext;
  NewStatusKeyExt := Self;
end;
{$ENDIF}
procedure RegisterGlobals;
begin
{$IFNDEF DELPHI32}
  RegisterType(RHCStatusLine);
{$ENDIF}
end;

end.
