{Run-time report editor}
{ (c) 1998 by Alexs    }
{$O+} {$I CompiOpt.inc}
unit Rpt_RnTm;
interface
uses Ext_Prn, Reports, Views, Objects, Drivers, DataCtrl, DB, ResTools,
     App, DBTable, Dialogs, DBCtrls, Forms, SysConst, Ext_Type, Clases;
const
  sNew_Template        = 40000;
  sSelectComponent     = sNew_Template + 1;
const
  cmInitRptEdit        = 40000;
  cmDoneRptEdit        = cmInitRptEdit       + 1;
  cmWizzard            = cmDoneRptEdit       + 1;
  cmNewTemplate        = cmWizzard           + 1;
  cmOpenTemplate       = cmNewTemplate       + 1;
  cmSaveTemplate       = cmOpenTemplate      + 1;
  cmTestTemplate       = cmSaveTemplate      + 1;
  cmCloseTemplate      = cmTestTemplate      + 1;
  cmProperty           = cmCloseTemplate     + 1;
  cmNewComponent       = cmProperty          + 1;
  cmComponentList      = cmNewComponent      + 1;
  cmDelElement         = cmComponentList     + 1;
  cmPackTemplate       = cmDelElement        + 1;

type
  PLockupRecord = ^TLockupRecord;
  TLockupRecord = record
    Name:PString;
    Value:longint;
    Next:PLockupRecord;
  end;
type
  PProperty = ^TProperty;

  TPropertyValidateEvent=function(Sender:PProperty; View:PView; Info:Pointer):boolean;
  TGetTextEvent=function(Sender:PProperty; View:PView):string;
  TEditEvent=procedure(Sender:PProperty; View:PView; Owner:PListBox);
  TPropertyNotifyEvent=procedure(Sender:PProperty; View:PView);

  TProperty = object(TObject)
    Name:PString;
    Offset:integer;
    Info:Pointer;
    HelpCtx:Word;
    OnGetText:TGetTextEvent;
    OnEdit:TEditEvent;
    OnBeforeEdit:TPropertyNotifyEvent;
    OnAfterEdit:TPropertyNotifyEvent;
    OnValidate:TPropertyValidateEvent;
    ReadOnly:boolean;
    constructor Init(AName:string; AOffset:Integer; AHelpCtx:word; AReadOnly:boolean);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
    procedure SetPointer(P:Pointer);virtual;
  private
    PViews:PView;
  end;


type
  PBooleanProperty = ^TBooleanProperty;
  TBooleanProperty = object(TProperty)
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
  end;


type
  PPStringProperty = ^TPStringProperty;
  TPStringProperty = object(TProperty)
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
  end;

type
  PStringProperty = ^TStringProperty;
  TStringProperty = object(TPStringProperty)
    MaxLen:Byte;
    constructor Init(AName:string; AOffset:Integer; AHelpCtx:word; AMaxLen:Byte; AReadOnly:boolean);
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
  end;

type
  TVariantRecord = record
    case itType:TIntegerType of
      0:(Result:Pointer);
      1:(LongResult:PLongint);
      2:(IntResult:PInteger);
      3:(WordResult:PWord);
      4:(ByteResult:PByte);
      5:(ShortIntResult:PShortInt);
      6:(CharResult:PChar);
      7:(DateTimeResult:PDateTime)
  end;

type
  PIntegerProperty = ^TIntegerProperty;
  TIntegerProperty = object(TProperty)
    Result:TVariantRecord;
    constructor Init(AName:string; AOffset:Integer; AHelpCtx:word; itType:TIntegerType; AReadOnly:boolean);
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
    procedure SetPointer(P:Pointer);virtual;
  end;

type
  PBitMapProperty = ^TBitMapProperty;
  TBitMapProperty = object(TProperty)
    Value:PStrings;
    EditValue:Longint;
    constructor Init(AName:string; AOffset:Integer; AHelpCtx:word;
                 Item:PSItem; AEditValue:Longint);
    destructor Done;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
  private
    BitList:PCollection;
  end;

type
  PBitBolProperty = ^TBitBolProperty;
  TBitBolProperty = object(TProperty)
    Owner:PBitMapProperty;
    BitVal:byte;
    constructor Init(AName:string; AOffset:Integer;
               AHelpCtx:word;ABitVal:byte; AReadOnly:boolean; AOwner:PBitMapProperty);
    function AsText:string;virtual;
    procedure EditProperty(ListBox:PListBox);virtual;
  end;

type
  PLockUpProperty = ^TLockUpProperty;
  TLockUpProperty = object(TBitMapProperty)
    constructor Init(AName:string; AOffset:Integer; AHelpCtx:word;
                 Item:PSItem; AReadOnly:boolean);
    procedure EditProperty(ListBox:PListBox);virtual;
    function AsText:string;virtual;
  end;

type
  PPropertyCollections = ^TPropertyCollections;
  TPropertyCollections = object(TSortedCollection)
    function Compare(Key1, Key2: Pointer): Integer; virtual;
  end;

const
  RProperty: TStreamRec = (
    ObjType: 20000;
    VmtLink: Ofs(TypeOf(TProperty)^);
    Load: @TProperty.Load;
    Store: @TProperty.Store);
const
  RPStringProperty: TStreamRec = (
    ObjType: 20001;
    VmtLink: Ofs(TypeOf(TPStringProperty)^);
    Load: @TPStringProperty.Load;
    Store: @TPStringProperty.Store);
const
  RStringProperty: TStreamRec = (
    ObjType: 20002;
    VmtLink: Ofs(TypeOf(TStringProperty)^);
    Load: @TStringProperty.Load;
    Store: @TStringProperty.Store);
const
  RIntegerProperty: TStreamRec = (
    ObjType: 20004;
    VmtLink: Ofs(TypeOf(TIntegerProperty)^);
    Load: @TIntegerProperty.Load;
    Store: @TIntegerProperty.Store);
const
  RBitMapProperty: TStreamRec = (
    ObjType: 20005;
    VmtLink: Ofs(TypeOf(TBitMapProperty)^);
    Load: @TBitMapProperty.Load;
    Store: @TBitMapProperty.Store);
const
  RBooleanProperty: TStreamRec = (
    ObjType: 20006;
    VmtLink: Ofs(TypeOf(TBooleanProperty)^);
    Load: @TBooleanProperty.Load;
    Store: @TBooleanProperty.Store);
const
  RLockUpProperty: TStreamRec = (
    ObjType: 20007;
    VmtLink: Ofs(TypeOf(TLockUpProperty)^);
    Load: @TLockUpProperty.Load;
    Store: @TLockUpProperty.Store);
const
  RPropertyCollections: TStreamRec = (
    ObjType: 20010;
    VmtLink: Ofs(TypeOf(TPropertyCollections)^);
    Load: @TPropertyCollections.Load;
    Store: @TPropertyCollections.Store);

type
   PPropertyListBox = ^TPropertyListBox;
   TPropertyListBox = object(TListBox)
      constructor Init(var Bounds: TRect; AScrollBar: PScrollBar);
      function GetText(Item: Integer; MaxLen: Integer): String; virtual;
   end;

type
   PPropertyWindow = ^TPropertyWindow;
   TPropertyWindow = object(TForm)
     PropertyListBox:PPropertyListBox;
     constructor Init;
     destructor Done;virtual;
     procedure HandleEvent(var Event:TEvent);virtual;
     procedure ReadPropertyList(P:PView);
     procedure EditCur;
     function GetHelpCtx: Word; virtual;
   end;

type
   TResourceListRec = record
     List:PResourceFile;
     Selection:integer;
   end;

type
   PResourceList = ^TResourceList;
   TResourceList = object(TListViewer)
     List:PResourceFile;
     function GetText(Item: Integer; MaxLen: Integer): String; virtual;
     procedure GetData(var Rec);virtual;
     procedure SetData(var Rec);virtual;
     function DataSize: Word; virtual;
     procedure SelectItem(Item: Integer);virtual;
   end;

var
  PropertyWindow:PPropertyWindow;


procedure InitReprtEditor(AMenuBar, AStatusLine:word; ADbf:PDbf);
procedure DoneReportEditor(AMenuBar, AStatusLine:word);
procedure ReportEditorHandleEvent(var Event:TEvent);

const
  ReportEditorRunign:boolean = false;
  CurEdit:PDialog = nil;
  CurDataSourse:PDbfSourse = nil;
  CurDbf:PDbf = nil;
  CurReport:PReport = nil;
  InfoPane:PStaticText = nil;
  TemplateFile:string[12] = 'TEMPLATE.TVR';
  Modified:boolean = false;
  ValidSet = [ctReport,ctReportBand,ctStaticText, ctDBText,ctReportLabel];
procedure AfterEditRBStile(Sender:PProperty; View:PView);far;
function GetTextDBTextField(Sender:PProperty; View:PView):string;far;
procedure EditDBTextField(Sender:PProperty; View:PView; Owner:PListBox);far;
procedure AfterEditRLStile(Sender:PProperty; View:PView);far;
function ValidComponentName(Sender:PProperty; View:PView; Info:Pointer):boolean;far;
function CreateResurseDlg(DelFlag:Boolean):PDialog;

procedure RegisterRpt_RnTm;
implementation
uses Cursors, Math, Ext_Dos, MsgBox, AddCntrl, Ext_Str, Validate;

procedure CloseTemplate;forward;
function CreateComponentListDlg:PDialog;forward;
procedure FillRecord( V:PView; var List:TListBoxRec);forward;
function FindByName( Name:string):PView;forward;
procedure UpDateInfoPane;forward;

function GetName(Form:PDialog; AView:PView):string;
var S:string;
    i:integer;
function Test(P:PView):boolean;far;
var b:boolean;
function DoTest(AP:PView):boolean;far;
begin
  if AP^.ComponentName<>nil then
     DoTest:=stUpCase(AP^.ComponentName^)=stUpCase(S+IntToStr(i))
  else DoTest:=false;
end;
begin
  if P^.ComponentName<>nil then
     B:=stUpCase(P^.ComponentName^)=stUpCase(S+IntToStr(i))
  else B:=false;
  if not b then
     if P^.ComponentType in [ctReportBand] then
        B:=PGroup(P)^.FirstThat(@DoTest)<>nil;
  Test:=B;
end;
begin
  i:=1;
  S:=AView^.ComponentName^;
  while Form^.FirstThat(@Test)<>nil do inc(i);
  GetName:=S+IntToStr(i);
end;

procedure InitReprtEditor(AMenuBar, AStatusLine:word; ADbf:PDbf);
var R:TRect;
begin
  _Cursor:=New(PCursor,Init);
  Application^.Delete(MenuBar);
  MenuBar^.Free;
  PView(MenuBar):=GetView(AMenuBar);
  Application^.Insert(MenuBar);

  Application^.Delete(StatusLine);
  StatusLine^.Free;
  PView(StatusLine):=GetView(AStatusLine);
  Application^.Insert(StatusLine);
  Application^.ReDraw;
  ReportEditorRunign:=true;
  CurDbf:=ADbf;
  Application^.InsertWindow(New(PPropertyWindow, Init));
  R.Assign(70,22,80,23);
  InfoPane:=New(PLabel, Init(R,'',nil));
  Desktop^.Insert(InfoPane);
end;

procedure DoneReportEditor(AMenuBar, AStatusLine:word);
begin
  if PropertyWindow<>nil then PropertyWindow^.Free;
  CloseTemplate;
  CurDbf^.Free;
  Application^.Delete(MenuBar);
  MenuBar^.Free;
  PView(MenuBar):=GetView(AMenuBar);
  Application^.Insert(MenuBar);

  Application^.Delete(StatusLine);
  StatusLine^.Free;
  PView(StatusLine):=GetView(AStatusLine);
  Application^.Insert(StatusLine);
  Application^.ReDraw;
  ReportEditorRunign:=false;
  InfoPane^.Free;
  if _Cursor<>nil then _Cursor^.Free;
end;

procedure SaveTemplate;
var List:PResourceFile;
    Mode:word;
    S:String;
    P:PGroup;
begin
  if (CurEdit=nil) or not Modified then exit;
  if FExists(TemplateFile) then Mode:=stOpen else Mode:=stCreate;
  S:='';
  List:=New(PResourceFile, Init(New(PDosStream, Init(TemplateFile, Mode))));
  if InputBox('࠭塞 蠡',' ',S,60)<>cmCancel then
  begin
     P:=_Cursor^.Owner;
     if P<>nil then P^.Delete(_Cursor);
     List^.Put(CurEdit,S);
     if P<>nil then P^.Insert(_Cursor);
     Modified:=false;
  end;
  List^.Free;
  UpDateInfoPane;
end;

procedure CloseTemplate;
begin
  if CurEdit<>nil then SaveTemplate;
  if CurEdit=nil then exit;
  _Cursor^.SetLink(nil);
  if _Cursor^.Owner<>nil then  _Cursor^.Owner^.Delete(_Cursor);
  CurEdit^.Free;
  CurEdit:=nil;
  CurDataSourse:=nil;
  CurReport:=nil;
  UpDateInfoPane;
end;

procedure OpenTemplate;
var Rec:TResourceListRec;
    Mode:word;
begin
  if CurEdit<>nil then CloseTemplate;
  if FExists(TemplateFile) then Mode:=stOpen else Mode:=stCreate;
  Rec.List:=New(PResourceFile, Init(New(PDosStream, Init(TemplateFile, Mode))));
  Rec.Selection:=0;
  case Application^.ExecuteDialog(CreateResurseDlg(true),@Rec) of
  cmOk:
    begin
      CurEdit:=PDialog(Application^.InsertWindow(PDialog(Rec.List^.Get(Rec.List^.KeyAt(Rec.Selection)))));
      CurDataSourse:=Message(CurEdit, evCommand, cmFindDataSourse, nil);
      CurDataSourse^.SetData(CurDbf);
      CurReport:=Message(CurEdit, evCommand, cmFindReport, Pointer(0));
    end;
  cmYes: Rec.List^.Delete(Rec.List^.KeyAt(Rec.Selection));
  end;
  Rec.List^.Free;
  UpDateInfoPane;
end;

procedure NewTemplate;
begin
  if CurEdit<>nil then CloseTemplate;
  Pointer(CurEdit):=Application^.InsertWindow(PWindow(GetView(sNew_Template)));
  CurEdit^.SetData(CurDbf);
  CurDataSourse:=Message(CurEdit, evCommand, cmFindDataSourse, nil);
  CurReport:=Message(CurEdit, evCommand, cmFindReport, Pointer(0));
  Modified:=true;
  UpDateInfoPane;
end;

procedure NewComponent;
var W:word;
    P:PView;
    D:PGroup;
begin
  if (Desktop^.Current<>Pointer(CurEdit)) or (CurEdit=nil) then exit;
  W:=0;
  if RExecDialog(sSelectComponent,@W)<>cmCancel then
  begin
     if (W<>2) and ((_Cursor^.Owner=nil) or
              (_Cursor^.Owner^.ComponentType<>ctReportBand) and
              (_Cursor^.EditView^.ComponentType<>ctReportBand)) then
        exit;
     P:=PView(ResourseFile.Get('_'+IntToStr(W)));
     AssignStr(P^.ComponentName, GetName(CurEdit, P));
     if W=2 then
     begin
       PReportBand(P)^.DataSourse:=CurDataSourse;
       PReportBand(P)^.Report:=CurReport;
       CurEdit^.Insert(PView(P));
     end
     else
     begin
       if _Cursor^.EditView^.ComponentType=ctReportBand then
          D:=PReportBand(_Cursor^.EditView)
       else
       if _Cursor^.Owner^.ComponentType=ctReportBand then
          D:=PReportBand(_Cursor^.Owner)
       else D:=CurEdit;
       if D<>nil then
       begin
         D^.Insert(PView(P));
         if W=1 then PDBText(P)^.DS:=CurDataSourse;
         if W=3 then PReportLabel(P)^.Report:=CurReport;
       end;
     end;
  end;
  Modified:=true;
  UpDateInfoPane;
end;

procedure MouseRightButton(var Event:TEvent);
var
  D:PGroup;
begin
  if (Desktop^.Current<>Pointer(CurEdit)) or (CurEdit=nil) then exit;
  D:=PGroup(Desktop^.Current);
  _Cursor^.SelectView(D, Event);
  D^.Redraw;
end;

procedure TestTemplate;
var P:PGroup;
begin
  if (Desktop^.Current<>Pointer(CurEdit)) or (CurEdit=nil) then exit;
  P:=_Cursor^.Owner;
  if P<>nil then P^.Delete(_Cursor);
  Message(CurEdit, evCommand, cmPreviewReport, nil);
  if P<>nil then P^.Insert(_Cursor);
end;

procedure ComponentList;
var Rec:TListBoxRec;
    S:string;
begin
  if CurEdit=nil then exit;
  FillRecord(_Cursor^.EditView,Rec);
  if Application^.ExecuteDialog(CreateComponentListDlg, @Rec)<>cmCancel then
  begin
    S:=PStrings(Rec.List)^.Str(Rec.Selection);
    _Cursor^.SetLink(FindByName(S));
  end;
  PObject(Rec.List)^.Free;
end;

procedure DelElement;
begin
  if (CurEdit=nil) or (_Cursor^.EditView=nil) then exit;
  if _Cursor^.EditView^.ComponentType=ctReport then exit;
  _Cursor^.EditView^.Free;
  _Cursor^.SetLink(nil);
  Modified:=true;
  UpDateInfoPane;
end;

procedure PackTemplate;
var F:PResourceFile;
    S,S1:PDosStream;
begin
  if not FExists(TemplateFile) then exit;
  S1:=New(PDosStream, Init(TemplateFile, stOpenRead));
  F:=New(PResourceFile, Init(S1));
  S:=New(PDosStream, Init('Template.$$$',stCreate));
  F^.SwitchTo(S,true);
  S1^.Free;
  F^.Free;
  BakUpFile(TemplateFile,'.bak',true);
  RenameFile('Template.$$$',TemplateFile);
end;

procedure ReportEditorHandleEvent(var Event:TEvent);
begin
  with Application^ do
  begin
    case Event.What of
      evMouseDown: if (Event.Buttons=mbRightButton) then MouseRightButton(Event)
                   else exit;
      evCommand:
      case Event.Command of
        cmWizzard:ExecDialog('RExp_1',nil);
        cmNewTemplate:NewTemplate;
        cmSaveTemplate:SaveTemplate;
        cmCloseTemplate:CloseTemplate;
        cmClose:if Desktop^.Current=Pointer(CurEdit) then CloseTemplate else exit;
        cmNewComponent:NewComponent;
        cmOpenTemplate:OpenTemplate;
        cmPreviewReport:TestTemplate;
        cmComponentList:ComponentList;
        cmDelElement:DelElement;
        cmPackTemplate:PackTemplate;
      else
        exit;
      end;
    evBroadcast:
      begin
         case Event.Command of
           cmCurSelect:if PropertyWindow<>nil then
                          PropertyWindow^.ReadPropertyList(Event.InfoPtr);
           cmCurentChang:if PropertyWindow<>nil then
                         begin
                            PropertyWindow^.PropertyListBox^.DrawView;
                            Modified:=true;
                            UpDateInfoPane;
                         end;
         end;
         exit;
      end;
    else
      exit;
    end;
    ClearEvent(Event);
  end;
end;

  {TPropertyListBox}
constructor TPropertyListBox.Init(var Bounds: TRect; AScrollBar: PScrollBar);
begin
  inherited Init(Bounds, 1, AScrollBar);
  GrowMode := gfGrowHiX + gfGrowHiY;

end;

function TPropertyListBox.GetText(Item: Integer; MaxLen: Integer): String;
var P:PProperty;
begin
   P:=List^.At(Item);
   GetText:=P^.Name^+': '+P^.AsText;
end;

   { TPropertyWindow }
constructor TPropertyWindow.Init;
var R:TRect;
    SB:PScrollBar;
begin
  R.Assign(  0,  7, 30, 23);
  inherited Init(R,'᮪ ᢮');
  Number:=GetNumberWindow;
  PropertyWindow:=@Self;
  Palette:=dpBlueDialog;
  GetExtent(R);
  SB:=StandardScrollBar(sbVertical or sbHandleKeyboard);
  R.Grow(-1, -1);
  PropertyListBox:=New(PPropertyListBox, Init(R, SB));
  Insert(PropertyListBox);
end;

destructor TPropertyWindow.Done;
begin
  PropertyWindow:=nil;
  PropertyListBox^.NewList(nil);
  inherited Done;
end;

procedure TPropertyWindow.EditCur;
var R:TRect;
    P:PInputLine;
    Prop:PProperty;
    S:String;
begin
  Prop:=PropertyListBox^.List^.At(PropertyListBox^.Focused);
  Prop^.EditProperty(PropertyListBox);
  if _Cursor^.EditView^.ComponentType in GroupControl then
     PGroup(_Cursor^.EditView)^.ReDraw
  else _Cursor^.EditView^.DrawView;
  Message(Application, evBroadcast, cmCurentChang, _Cursor^.EditView);
  PropertyListBox^.DrawView;
end;

procedure TPropertyWindow.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evBroadcast:
    case Event.Command of
      cmCurSelect:ReadPropertyList(Event.InfoPtr);
      cmListItemSelected:if Event.InfoPtr=PropertyListBox then
                         EditCur;
    else
      exit
    end;
  else
    exit;
  end;
end;

procedure TPropertyWindow.ReadPropertyList(P:PView);
var LL:PCollection;
procedure Assign(Item:PProperty);far;
begin
  Item^.SetPointer(P);
end;
begin
  if P<>nil then
     LL:=PCollection(ResourseFile.Get('P_'+IntToStr(Byte(P^.ComponentType))))
  else LL:=nil;
  if LL<>nil then LL^.ForEach(@Assign);
  PropertyListBox^.NewList(LL);
end;

function TPropertyWindow.GetHelpCtx: Word;
var
  Prop:PProperty;
begin
  if PropertyListBox^.List<>nil then
  begin
    Prop:=PropertyListBox^.List^.At(PropertyListBox^.Focused);
    GetHelpCtx:=Prop^.HelpCtx;
  end
  else
   GetHelpCtx:=inherited GetHelpCtx;
end;

 { TResourceList }
function TResourceList.GetText(Item: Integer; MaxLen: Integer): String;
begin
  GetText:=List^.KeyAt(Item);
end;

procedure TResourceList.GetData(var Rec);
var A:TResourceListRec absolute Rec;
begin
  A.Selection:=Focused;
end;

procedure TResourceList.SetData(var Rec);
var A:TResourceListRec absolute Rec;
begin
  List:=A.List;
  if List<>nil then SetRange(List^.Count)
  else SetRange(0);
  FocusItem(A.Selection);
end;

function TResourceList.DataSize: Word;
begin
  DataSize:=SizeOf(TResourceListRec);
end;

procedure TResourceList.SelectItem(Item: Integer);
var
  E: TEvent;
begin
  inherited SelectItem(Item);
  with E do
  begin
    What := evCommand;
    Command := cmOk;
    InfoPtr := nil;
  end;
  PutEvent(E);
end;

function CreateResurseDlg(DelFlag:Boolean):PDialog;
var D:PDialog;
    R:TRect;
    P:PView;
begin
   R.Assign( 10,  4, 70, 19);
   D:=New(PDialog,Init(R,'롥 蠡'));
   with D^ do
   begin
      R.Assign( 45,  1, 46, 14);
        P:=New(PScrollBar, Init( R));
        Insert(P);
      R.Assign(  1,  1, 45, 14);
        Insert(New(PResourceList, Init( R, 1, nil, PScrollBar(P))));
      R.Assign( 48,  2, 59,  4);
        Insert(New(PButton, Init( R, '~~', cmOK, bfDefault)));
      R.Move(0,2);
        Insert(New(PButton, Init( R, '⬥', cmCancel, bfNormal)));
      if DelFlag then
      begin
        R.Move(0,3);
          Insert(New(PButton, Init( R, '~~', cmYes, bfNormal)));
      end;
      R.Move(0,4);
        Insert(New(PButton, Init( R, '~~', cmHelp, bfNormal)));
      SelectNext(false);
   end;
   CreateResurseDlg:=D;
end;

procedure AfterEditRBStile(Sender:PProperty; View:PView);
var RB:PReportBand absolute View;
begin
  RB^.Report^.SetReportBand(RB, RB^.RBType);
end;

procedure AfterEditRLStile(Sender:PProperty; View:PView);
var RL:PReportLabel absolute View;
begin
  case RL^.RLStyle of
    rlsDate, rlsTime, rlsDateTime:AssignStr(RL^.ParamStr, '%s');
    rlsPageNo:AssignStr(RL^.ParamStr, '- %d -');
    rlsLineNo:AssignStr(RL^.ParamStr, '%d');
  end;
end;

function GetTextDBTextField(Sender:PProperty; View:PView):string;
var DBText:PDBText absolute View;
begin
  if DBText^.Field<>nil then GetTextDBTextField:=DBText^.Field^.Name^
  else GetTextDBTextField:='';
end;

function ValidComponentName(Sender:PProperty; View:PView; Info:Pointer):boolean;
var S:PString absolute Info;
    Result:Boolean;

function DoFind(P:PView):boolean;far;
function DoTest(AP:PView):boolean;far;
begin
  if AP^.ComponentName<>nil then
     DoTest:=stUpCase(AP^.ComponentName^)=stUpCase(S^)
  else DoTest:=false;
end;
begin
  if P^.ComponentName<>nil then
     if stUpCase(P^.ComponentName^)=stUpCase(S^) then DoFind:=true
     else
       if P^.ComponentType in [ctReportBand] then
          DoFind:=PGroup(P)^.FirstThat(@DoTest)<>nil
       else DoFind:=false
  else DoFind:=false;
end;

begin
  Result:=CurEdit^.FirstThat(@DoFind)=nil;
  if not Result then
     MessageBox(^C'''%s'' -   㦥 ᯮ.',@S, mfError+mfOkButton);
  ValidComponentName:=Result;
end;

function CreateListField(Sender:PProperty; DS:PDataSourse; CurField:PField;
                         Owner:PListBox; var PL:PLockUpInputLine):Longint;
var i,l:longint;
    R:TRect;
procedure DoAdd(P:PField);far;
begin
  if P=CurField then L:=i;
  PL^.List^.AtInsert(i, NewStr(P^.Name^));
  inc(i);
end;
begin
  with Owner^ do
  R.Assign(Origin.X+Length(Sender^.Name^)+2, Origin.Y+Focused-TopItem,
           Origin.X+Size.X, Origin.Y+Focused-TopItem+1);
  PL:=New(PLockUpInputLine, Init(R,nil));
  CreateListField:=-1;
  if (DS=nil) or not DS^.Active then exit;
  i:=0;
  DS^.FieldDefs^.ForEach(@DoAdd);
  PL^.SetData(L);
  CreateListField:=L;
end;

procedure EditDBTextField(Sender:PProperty; View:PView; Owner:PListBox);
var L:longint;
    i:integer;
    P:PLockUpInputLine;
    DBText:PDBText absolute View;
begin
  L:=CreateListField(Sender, DBText^.DS, DBText^.Field, Owner, P);
  if Owner^.Owner^.ExecView(P)=cmOk then
  begin
    P^.GetData(L);
    if L=-1 then DBText^.Field:=nil
    else
    if DBText^.DS^.Active then DBText^.Field:=DBText^.DS^.Field(L)
    else DBText^.Field:=nil;
    if DBText^.Field=nil then
    begin
      DisposeStr(DBText^.FieldName);
      DBText^.FieldName:=nil;
    end
    else AssignStr(DBText^.FieldName, DBText^.Field^.Name^)
  end;
  P^.Free;
end;

function CreateComponentListDlg:PDialog;
var R:TRect;
    ScrollBar1:PScrollBar;
    Form1:PDialog;
begin
   R.Assign( 15,  2, 61, 20);
   Form1:=New(PDialog,Init(R,'᮪ ⮢...'));
   with Form1^ do
   begin
      R.Assign( 32,  1, 33, 17);
        ScrollBar1:=New(PScrollBar, Init( R));
        Insert(ScrollBar1);
      R.Assign(  1,  1, 32, 17);
        Insert(New(POkListBox, Init( R,1, ScrollBar1)));
      R.Assign( 34,  2, 44,  4);
        Insert(New(PButton, Init( R, '~O~k', cmOK, bfDefault)));
      R.Assign( 34,  4, 44,  6);
        Insert(New(PButton, Init( R, 'Cancel', cmCancel, bfNormal)));
      R.Assign( 34, 10, 44, 12);
        Insert(New(PButton, Init( R, '~H~elp', cmHelp, bfNormal)));
      SelectNext(false);
   end;
   CreateComponentListDlg:=Form1;
end;

procedure FillRecord( V:PView; var List:TListBoxRec);
var I:integer;
procedure Fill(P:PView);far;
procedure DoFill(P:PView);far;
begin
   if P^.ComponentType in ValidSet then
   begin
      PCollection(List.List)^.Insert(NewStr(P^.ComponentName^));
      if P=V then List.Selection:=I;
      inc(i);
    end;
end;

begin
   if P^.ComponentType in ValidSet then
   begin
      PCollection(List.List)^.Insert(NewStr(P^.ComponentName^));
      if P=V then List.Selection:=I;
      inc(i);
      if P^.ComponentType = ctReportBand then
         PGroup(P)^.ForEach(@DoFill);
    end;
end;

begin
  FillChar(List, SizeOf(TListBoxRec), 0);
  List.List:=New(PStrings, Init);
  I:=0;
  CurEdit^.ForEach(@Fill);
end;

function FindByName( Name:string):PView;
var PP:PView;
function Test(P:PView):Boolean;far;
function DoTest(P:PView):Boolean;far;
begin
  if (P^.ComponentName<>nil) and (P^.ComponentName^=Name) then
  begin
    DoTest:=true;
    PP:=P;
  end else DoTest:=false;
end;

begin
  Test:=false;
  if (P^.ComponentName<>nil) and (P^.ComponentName^=Name) then Test:=true
  else
  if P^.ComponentType = ctReportBand then
     Test:=PGroup(P)^.FirstThat(@DoTest)<>nil;
end;
begin
  PP:=nil;
  FindByName:=CurEdit^.FirstThat(@Test);
  if PP<>nil then FindByName:=PP;
end;

procedure UpDateInfoPane;
var S:string;
begin
  if Modified then S:='' else S:='';
  AssignStr(InfoPane^.Text,S);
  InfoPane^.DrawView;
end;

 {TProperty}
constructor TProperty.Init(AName:string; AOffset:Integer; AHelpCtx:word;
                      AReadOnly:boolean);
begin
  inherited Init;
  Name:=NewStr(AName);
  Offset:=AOffset;
  HelpCtx:=AHelpCtx;
  ReadOnly:=AReadOnly;
end;

destructor TProperty.Done;
begin
  DisposeStr(NAme);
  inherited Done;
end;

constructor TProperty.Load(var S:TStream);
begin
  inherited Init;
  Name:=S.ReadStr;
  S.Read(Offset, SizeOf(Integer));
  S.Read(HelpCtx, SizeOf(Word));
  S.Read(ReadOnly, SizeOf(boolean));
  LoadProcedure(S,@OnGetText);
  LoadProcedure(S,@OnEdit);
  LoadProcedure(S,@OnBeforeEdit);
  LoadProcedure(S,@OnAfterEdit);
  LoadProcedure(S,@OnValidate);
end;

procedure TProperty.Store(var S:TStream);
begin
  S.WriteStr(Name);
  S.Write(Offset, SizeOf(Integer));
  S.Write(HelpCtx, SizeOf(Word));
  S.Write(ReadOnly, SizeOf(boolean));
  StoreProcedure(S,@OnGetText);
  StoreProcedure(S,@OnEdit);
  StoreProcedure(S,@OnBeforeEdit);
  StoreProcedure(S,@OnAfterEdit);
  StoreProcedure(S,@OnValidate);
end;

function TProperty.AsText:string;
begin
  if Assigned(OnGetText) then AsText:=OnGetText(@Self, PViews)
  else AsText:='';
end;

procedure TProperty.EditProperty(ListBox:PListBox);
begin
  if ReadOnly then exit;
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox);
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;

procedure TProperty.SetPointer(P:Pointer);
begin
  PViews:=P;
  Info:=Ptr(PtrRec(P).Seg,PtrRec(P).Ofs+Offset+VMTOffset);
end;

function EditeDate(var S:string; ListBox:PListBox; MaxLen:byte; V:PValidator):boolean;
var R:TRect;
    P:PInputLine;
    Prop:PProperty;
    ModalResult:word;
begin
  with ListBox^ do
  begin
    Prop:=List^.At(Focused);
    S:=Prop^.AsText;
    R.Assign(Origin.X+Length(Prop^.Name^)+2, Origin.Y+Focused-TopItem,
             Origin.X+Size.X, Origin.Y+Focused-TopItem+1);
    P:=New(PInputLine, Init(R, MaxLen));
    P^.SetValidator(V);
    P^.SetData(S);
    ModalResult:=Owner^.ExecView(P);
  end;
  if ModalResult=cmOk then P^.GetData(S);
  EditeDate:=ModalResult=cmOk;
  P^.Free;
end;

 {TPStringProperty}
function TPStringProperty.AsText:string;
begin
  if PString(Info^)<>nil then AsText:=PString(Info^)^
  else AsText:='';
end;

procedure TPStringProperty.EditProperty(ListBox:PListBox);
var PS:PString;
    S:String;
    B:boolean;
begin
  if ReadOnly then exit;
  PS:=PString(Info^);
  if PS<>nil then S:=PS^ else S:='';
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox)
  else
  if EditeDate(S, ListBox, 255, nil) then
  begin
    if Assigned(OnValidate) then B:=OnValidate(@Self, PViews, @S)
    else B:=true;
    if B then
    begin
      if PS<>nil then DisposeStr(PS);
      PS:=NewStr(S);
      PString(Info^):=PS;
    end;
    _Cursor^.Owner^.ReDraw;
  end;
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;

  { TStringProperty }
constructor TStringProperty.Init(AName:string; AOffset:Integer;
            AHelpCtx:word; AMaxLen:Byte; AReadOnly:boolean);
begin
  inherited Init(AName, AOffset, AHelpCtx, AReadOnly);
  MaxLen:=AMaxLen;
end;

constructor TStringProperty.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read(MaxLen, SizeOf(Byte));
end;

procedure TStringProperty.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(MaxLen, SizeOf(Byte));
end;

function TStringProperty.AsText:string;
begin
  AsText:=PString(Info)^;
end;

procedure TStringProperty.EditProperty;
var S:String;
begin
  if ReadOnly then exit;
  S:=PString(Info)^;
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox)
  else
  if EditeDate(S, ListBox, MaxLen, nil) then
    move(S, PString(Info)^, MaxLen+1);
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;

 { TBitMapProperty }
constructor TBitMapProperty.Init(AName:string; AOffset:Integer;AHelpCtx:word;
                         Item:PSItem; AEditValue:Longint);
var I:PSItem;
begin
  inherited Init('+'+AName, AOffset, AHelpCtx, false);
  Value:=New(PStrings, Init);
  while Item<>nil do
  begin
    Value^.Insert(Item^.Value);
    I:=Item;
    Item:=Item^.Next;
    Dispose(I);
  end;
  EditValue:=AEditValue;
end;

destructor TBitMapProperty.Done;
begin
  Value^.Free;
  if BitList<>nil then
  begin
    BitList^.DeleteAll;
    BitList^.Free;
  end;
  inherited Done;
end;

constructor TBitMapProperty.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read(EditValue, SizeOf(Longint));
  Value:=PStrings(S.Get);
end;

procedure TBitMapProperty.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(EditValue, SizeOf(Longint));
  S.Put(Value);
end;

function TBitMapProperty.AsText:string;
var i:integer;
    S:string;
begin
  if BitList<>nil then S:='[' else S:='[';
  for I:=0 to Value^.Count-1 do
      if (i in PByteSet(Info)^) and (Value^.Str(i)<>'!') then S:=S+Value^.Str(i)+',';
  if Length(S)>2 then dec(s[0]);
  AsText:=S+']';
end;

procedure TBitMapProperty.EditProperty(ListBox:PListBox);
var P:PBitBolProperty;
    Pos,i:integer;
    W:longint;
function DoFind(P:Pointer):boolean;far;
begin
  DoFind:=P=@Self;
  inc(Pos);
end;
begin
  Pos:=-1;
  ListBox^.List^.FirstThat(@DoFind);
  if BitList<>nil then
  begin
    for I:=0 to Value^.Count-1 do
      if Value^.Str(i)<>'!' then
         ListBox^.List^.AtDelete(Pos+1);
    BitList^.Free;
    BitList:=nil;
    Name^[1]:='+';
  end
  else
  begin
    Name^[1]:='-';
    W:=1;
    BitList:=New(PCollection, Init(20,10));
    for I:=Value^.Count-1 downto 0 do
    if Value^.Str(i)<>'!' then
    begin
      P:=New(PBitBolProperty, Init('  '+Value^.Str(i),Offset,HelpCtx,i,
             (EditValue and (W shl i))<>0, @Self));
      P^.SetPointer(PViews);
      BitList^.Insert(P);
      ListBox^.List^.AtInsert(Pos+1,P);
    end;
  end;
  ListBox^.SetRange(ListBox^.List^.Count);
end;

  { TBitBolProperty }
constructor TBitBolProperty.Init(AName:string; AOffset:Integer;
                  AHelpCtx:word;ABitVal:byte; AReadOnly:boolean; AOwner:PBitMapProperty);
begin
  inherited Init(AName, AOffset, AHelpCtx, AReadOnly);
  BitVal:=ABitVal;
  Owner:=AOwner;
  OnGetText:=Owner^.OnGetText;
  OnEdit:=Owner^.OnEdit;
  OnBeforeEdit:=Owner^.OnBeforeEdit;
  OnAfterEdit:=Owner^.OnAfterEdit;
end;

function TBitBolProperty.AsText:string;
begin
  AsText:=BooleanToStr(BitVal in PByteSet(Info)^);
end;

procedure TBitBolProperty.EditProperty(ListBox:PListBox);
begin
  if ReadOnly then exit;
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox)
  else
  if BitVal in PByteSet(Info)^ then PByteSet(Info)^:=PByteSet(Info)^-[BitVal]
  else PByteSet(Info)^:=PByteSet(Info)^+[BitVal];
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;

  { TLockUpProperty }
constructor TLockUpProperty.Init(AName:string; AOffset:Integer; AHelpCtx:word;
                 Item:PSItem; AReadOnly:boolean);
var I:PSItem;
begin
  TProperty.Init(AName, AOffset, AHelpCtx, AReadOnly);
  Value:=New(PStrings, Init);
  while Item<>nil do
  begin
    Value^.Insert(Item^.Value);
    I:=Item;
    Item:=Item^.Next;
    Dispose(I);
  end;
end;

function TLockUpProperty.AsText:string;
begin
  if (PByte(Info)^>-1) and (PByte(Info)^<Value^.Count) then
     AsText:=Value^.Str(PByte(Info)^)
  else AsText:='';
end;

procedure TLockUpProperty.EditProperty(ListBox:PListBox);
var P:PLockUpInputLine;
    R:TRect;
    L:longint;
    i:integer;
begin
  if ReadOnly then exit;
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox)
  else
  with ListBox^ do
  begin
     R.Assign(Origin.X+Length(Name^)+2, Origin.Y+Focused-TopItem,
              Origin.X+Size.X, Origin.Y+Focused-TopItem+1);
     L:=PByte(Info)^;
     P:=New(PLockUpInputLine, Init(R,nil));
     for i:=0 to Value^.Count-1 do
           P^.List^.AtInsert(i, NewStr(Value^.Str(i)));
     P^.SetData(L);
     if ListBox^.Owner^.ExecView(P)=cmOk then
     begin
       P^.GetData(L);
       PByte(Info)^:=L;
     end;
     P^.Free;
  end;
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;


  { TItegerProperty }
constructor TIntegerProperty.Init(AName:string; AOffset:Integer;
                     AHelpCtx:word; itType:TIntegerType; AReadOnly:boolean);
begin
  inherited Init(AName,AOffset, AHelpCtx, AReadOnly);
  Result.itType:=itType;
end;

constructor TIntegerProperty.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read(Result.itType, SizeOf(TIntegerType));
end;

procedure TIntegerProperty.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(Result.itType, SizeOf(TIntegerType));
end;

function TIntegerProperty.AsText:string;
var L:Longint;
begin
  with Result do
  case itType of
     itShortint:L:=ShortIntResult^;
     itInteger:L:=IntResult^;
     itLongint:L:=LongResult^;
     itByte:L:=ByteResult^;
     itWord:L:=WordResult^;
     itChar:begin
              AsText:=CharResult^;
              exit;
            end;
     itDate:
            begin
              AsText:=DateToStr(DateTimeResult^);
              exit;
            end;
     itTime:
            begin
              AsText:=TimeToStr(DateTimeResult^);
              exit;
            end;
  end;
  AsText:=IntToStr(L);
end;

procedure TIntegerProperty.EditProperty;
var S:String;
    V:PValidator;
    MaxLen:integer;
begin
  if ReadOnly then exit;
  MaxLen:=255;
  V:=nil;
  case Result.itType of
     itShortInt:begin
                  S:=IntToStr(Result.ShortIntResult^);
                  V:=New(PRangeValidator, Init(-128,127));
                end;
     itInteger:begin
                  S:=IntToStr(Result.IntResult^);
                  V:=New(PRangeValidator, Init(-32768,32767));
               end;
     itLongint:begin
                  S:=IntToStr(Result.LongResult^);
                  V:=New(PRangeValidator, Init(-2147483647-1,2147483647));
               end;
     itByte:begin
               S:=IntToStr(Result.ByteResult^);
               V:=New(PRangeValidator, Init(0,255));
            end;
     itWord:begin
               S:=IntToStr(Result.WordResult^);
               V:=New(PRangeValidator, Init(0, 65535));
            end;
     itChar:begin
              S:=Result.CharResult^;
              MaxLen:=1;
            end;
     itDate:begin
              S:=DateToStr(Result.DateTimeResult^);
              V:=New(PPXPictureValidator,
                 Init('{#[#]}'+DateChar+'{#[#]}'+DateChar+'{##[##]}',true))
            end;
     itTime:begin
              S:=TimeToStr(Result.DateTimeResult^);
              V:=New(PPXPictureValidator,
                 Init('{#[#]}'+TimeChar+'{#[#]}'+TimeChar+'{#[#]}',true))
            end;
  end;
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox)
  else
    if EditeDate(S, ListBox, MaxLen, V) then
    case Result.itType of
       itShortint:Result.ShortIntResult^:=StrToInt(S);
       itInteger:Result.IntResult^:=StrToInt(S);
       itLongint:Result.LongResult^:=StrToInt(S);
       itByte:Result.ByteResult^:=StrToInt(S);
       itWord:Result.WordResult^:=StrToInt(S);
       itChar:Result.CharResult^:=S[1];
       itDate:Result.DateTimeResult^:=StrToDate(S);
       itTime:Result.DateTimeResult^:=StrToTime(S);
    end;
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;

procedure TIntegerProperty.SetPointer(P:Pointer);
begin
  PViews:=P;
  Result.Result:=Ptr(PtrRec(P).Seg,PtrRec(P).Ofs+Offset+VMTOffset);
end;

  { TBoleanProperty }
function TBooleanProperty.AsText:string;
begin
  AsText:=BooleanToStr(PBoolean(Info)^);
end;

procedure TBooleanProperty.EditProperty(ListBox:PListBox);
begin
  if ReadOnly then exit;
  if Assigned(OnBeforeEdit) then OnBeforeEdit(@Self, PViews);
  if Assigned(OnEdit) then OnEdit(@Self, PViews, ListBox)
  else PBoolean(Info)^:=not PBoolean(Info)^;
  if Assigned(OnAfterEdit) then OnAfterEdit(@Self, PViews);
end;


  { TPropertyCollections }
function TPropertyCollections.Compare(Key1, Key2: Pointer): Integer;
var PR1:PProperty absolute Key1;
    PR2:PProperty absolute Key2;
    S1,S2:string;
function DelSign(const S:string):string;
begin
  if (S[1]='-') or (S[1]='+') then DelSign:=Copy(S,2,255)
  else DelSign:=S;
end;

begin
   S1:=DelSign(stUpCase(PR1^.Name^));
   S2:=DelSign(stUpCase(PR2^.Name^));
   if S1<S2 then Compare:=-1
   else
   if S1>S2 then Compare:=1
   else Compare:=0;
end;

procedure RegisterRpt_RnTm;
begin
  Cursors.GroupControl:=[ctReportBand];
  Cursors.BackGComp:=[ctReportBandBackground, ctFrame];
  RegisterProcedure(@AfterEditRBStile, 100, '');
  RegisterProcedure(@GetTextDBTextField, 101, '');
  RegisterProcedure(@EditDBTextField, 102, '');
  RegisterProcedure(@AfterEditRLStile, 103, '');
  RegisterProcedure(@ValidComponentName, 104,'');
  RegisterType(RProperty);
  RegisterType(RPStringProperty);
  RegisterType(RStringProperty);
  RegisterType(RIntegerProperty);
  RegisterType(RBitMapProperty);
  RegisterType(RBooleanProperty);
  RegisterType(RLockUpProperty);
  RegisterType(RPropertyCollections);
end;

end.
