{************************************************}
{                                                }
{   Large text editor utilites                   }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}

unit ShardEdt;
interface
uses Objects, Views, Drivers, Dialogs, Register;
const
  MaxLineLength = 256;
const
  CIndicator    = #2#3;
  CEditor       = #6#7;
  CMemo         = #26#27;
const
  FindStrSize   = 80;
const
  kbShift = kbLeftShift+kbRightShift;
  ToClipCmds    = ([cmCut,cmCopy]);
  FromClipCmds  = ([cmPaste]);
  NulClipCmds   = ([cmClear]);
  UndoCmds      = ([cmUndo, cmRedo]);
const
  efBackupFiles         = $0001;
  efInsertMode          = $0002;
  efAutoIndent          = $0004;
  efUseTabCharacters    = $0008;
  efOptimalFill         = $0010;
  efBackSpaceUnindents  = $0020;
  efCursorThroughTabs   = $0040;
  efGroupUndo           = $0080;
  efPersistentBlocks    = $0100;
  efOverwriteBlocks     = $0200;
  efSyntaxHighlight     = $0400;
  efBlockInsCursor      = $0800;
  efFindTextAtCursor    = $1000;
{  efVerticalBlocks      = $00000200;
  efHighlightColumn     = $00000400;
  efHighlightRow        = $00000800;
  efAutoBrackets        = $00001000;}

const
  edOutOfMemory         = 0;
  edReadError           = edOutOfMemory         + 1;
  edWriteError          = edReadError           + 1;
  edCreateError   = 3;
  edSaveModify    = 4;
  edSaveUntitled  = 5;
  edSaveAs        = 6;
  edFind          = 7;
  edSearchFailed  = 8;
  edReplace       = 9;
  edReplacePrompt = 10;
  edTooManyLines  = 11;
  edGotoLine      = 12;
  edReplaceFile   = 13;
  edPrintFile     = 14;
  edReadBlock           = edPrintFile           + 1;
  edWriteBlock          = edReadBlock           + 1;

const
  ffCaseSensitive       = $0001;
  ffWholeWordsOnly      = $0002;
  ffRegularExpression   = $0004;
  ffPromptOnReplace     = $0008;

  ffGlobal              = $0000;
  ffSelectedText        = $0010;

  ffForward             = $0000;
  ffBackward            = $0020;

  ffFromCursor          = $0000;
  ffEntireScope         = $0040;

  ffReplace             = $8000;
  ffReplaceAll          = $4000;

type
  TStdEditorOptionsRec = record
    EditorFlags:word;
    TabSize:Longint;
    HighlightExt:string[128];
  end;

type
  TStdEditorFindRec=record
    TextToFind:string;
    Options:word;
    Scope:word;
    Direction:word;
    Origin:word;
  end;

type
  TStdEditorReplaseRec=record
    TextToFind:string;
    NewText:string;
    Options:word;
    Scope:word;
    Direction:word;
    Origin:word;
  end;

const
  FindStr      : string[FindStrSize] = '';
  ReplaceStr   : string[FindStrSize] = '';
  FindFlags    : word = ffPromptOnReplace;
const
  HighlightExt : string[128] = '';
const
  EditorFlags : Longint   = efPersistentBlocks   +
{                            efUseTabCharacters +}
                            efBackspaceUnindents +
                            efAutoIndent         +
                            efOptimalFill        +
                            efFindTextAtCursor   +
                            efSyntaxHighlight    +
                            efBackupFiles;
  TabSize     : integer   = 8;

function StdEditorGotoLineDlg:PDialog;
function StdEditorOptionsDlg:PDialog;
function StrEditorFindDlg:PDialog;
function StdEditorReplaseDlg:PDialog;
implementation
uses AddCntrl, Std_Str, Clases;


function StdEditorGotoLineDlg:PDialog;
var R:TRect;
    P:PRangeILine;
    D:PDialog;
begin
   R.Assign( 0,  0, 40, 7);
   D:=New(PDialog,Init(R,strGoToLineNumber));
   with D^ do
   begin
      Options:=Options + ofCentered;
      R.Assign( 25,  2, 36,  3);
        P:=Insert(New(PRangeILine, Init( R,0, MaxLongint)));
      R.Assign( 36,  2, 39,  3);
        Insert(New(PHistory, Init( R, P, 120)));
      R.Assign(  2,  2, 25,  3);
        Insert(New(PLabel, Init( R,strEnterLineNumber, P)));
      R.Assign(  2,  4, 12,  6);
        Insert(New(PButton, Init( R, strOk, cmOK, bfDefault)));
      R.Assign( 14,  4, 24,  6);
        Insert(New(PButton, Init( R, strCancel, cmCancel, bfNormal)));
      R.Assign( 26,  4, 36,  6);
        Insert(New(PButton, Init( R, strHelp, cmHelp, bfNormal)));
      SelectNext(false);
   end;
   StdEditorGotoLineDlg:=D;
end;

function StdEditorOptionsDlg:PDialog;
var R:TRect;
    P:PView;
    Form:PDialog;
begin
  R.Assign( 12,  2, 68, 21);
  Form:=New(PDialog,Init(R,strEditOptions));
  with Form^ do
  begin
     R.Assign(  3,  3, 53, 10);
       P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem(strCreateBackup,
                  NewSItem(strInsertMode,
                  NewSItem(strAutoIndent,
                  NewSItem(strUseTabChars,
                  nil)))))));
(*//                  NewSItem({$IFDEF RUS}'⨬쭮 .'{$ELSE}'~O~ptimal fill'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'⮮  '{$ELSE}'~B~ackspace unindents'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'~~  TAB'{$ELSE}'~C~ursor through tabs'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'㯯 㭤'{$ELSE}'~G~roup Undo'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'ﭭ '{$ELSE}'~P~ersistent blocks'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'१ '{$ELSE}'O~v~erwrite blocks'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'ᢥ⪠ ᨭ⠪'{$ELSE}'~S~yntax highlight'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'⠢ -'{$ELSE}'B~l~ock insert cursor'{$ENDIF},
//                  NewSItem({$IFDEF RUS}'᪠ ⥪  ஬'{$ELSE}'Find te~x~t at cursor'{$ENDIF},
//                 nil)))))))))*)
     R.Assign(  2,  2, 21,  3);
       Insert(New(PLabel, Init( R ,strEditOptions, P)));
     R.Assign( 12, 11, 16, 12);
       P:=Insert(New(PRangeILine, Init( R, 0, 20)));
     R.Assign(  2, 11, 11, 12);
       Insert(New(PLabel, Init( R ,'~T~ab size', P)));
     R.Assign(  3, 14, 50, 15);
       P:=Insert(New(PInputLine, Init( R, 128)));
     R.Assign( 50, 14, 53, 15);
       Insert(New(PHistory, Init( R, PInputLine(P), 100)));
     R.Assign(  2, 13, 26, 14);
       Insert(New(PLabel, Init( R ,'~H~ighlight extensions', P)));
     R.Assign( 19, 16, 29, 18);
       Insert(New(PButton, Init( R , strOk, cmOK, bfDefault)));
     R.Assign( 31, 16, 41, 18);
       Insert(New(PButton, Init( R , strCancel, cmCancel, bfNormal)));
     R.Assign( 43, 16, 53, 18);
       Insert(New(PButton, Init( R , strHelp, cmHelp, bfNormal)));
     SelectNext(false);
  end;
  StdEditorOptionsDlg:=Form;
end;

function StrEditorFindDlg:PDialog;
var R:TRect;
    P:PView;
    FindForm:PDialog;
begin
   R.Assign( 12,  3, 67, 19);
   FindForm:=New(PDialog,Init(R,'Find'));
   with FindForm^ do
   begin
      R.Assign( 16,  2, 49,  3);
        P:=Insert(New(PInputLine, Init( R, 255)));
      R.Assign( 49,  2, 52,  3);
        Insert(New(PHistory, Init( R, PInputLine(P), 122)));
      R.Assign(  2,  2, 16,  3);
        Insert(New(PLabel, Init( R, '~T~ext to find', P)));
      R.Assign(  3,  5, 27,  8);
        P:=Insert(New(PCheckBoxes, Init( R ,
                  NewSItem('~C~ase sensitive',
                  NewSItem('~W~hole words only',
                  NewSItem('~R~egular expression',
                  nil))))));
      R.Assign(  2,  4, 21,  5);
        Insert(New(PLabel, Init( R ,'Options', P)));
      R.Assign(  3, 10, 27, 12);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('~G~lobal',
                  NewSItem('~S~elected text',
                  nil)))));
      R.Assign(  2,  9, 21, 10);
        Insert(New(PLabel, Init( R ,'Scope', P)));
      R.Assign( 30,  5, 52,  7);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('Forwar~d~',
                  NewSItem('~B~ackward',
                  nil)))));
      R.Assign( 29,  4, 48,  5);
        Insert(New(PLabel, Init( R ,'Direction', P)));
      R.Assign( 30, 10, 52, 12);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('~F~rom cursor',
                  NewSItem('~E~ntire scope',
                  nil)))));
      R.Assign( 29,  9, 48, 10);
        Insert(New(PLabel, Init( R ,'Origin', P)));
      R.Assign( 18, 13, 28, 15);
        Insert(New(PButton, Init( R , '~O~k', cmOK, bfDefault)));
      R.Assign( 30, 13, 40, 15);
        Insert(New(PButton, Init( R , 'Cancel', cmCancel, bfNormal)));
      R.Assign( 42, 13, 52, 15);
        Insert(New(PButton, Init( R , '~H~elp', cmHelp, bfNormal)));
      SelectNext(false);
   end;
   StrEditorFindDlg:=FindForm;
end;

function StdEditorReplaseDlg:PDialog;
var R:TRect;
    P:PView;
    ReplaseForm:PDialog;
begin
   R.Assign( 12,  2, 67, 21);
   ReplaseForm:=New(PDialog,Init(R,'Replase'));
   with ReplaseForm^ do
   begin
      R.Assign( 16,  2, 49,  3);
        P:=Insert(New(PInputLine, Init( R ,255)));
      R.Assign( 49,  2, 52,  3);
        Insert(New(PHistory, Init( R, PInputLine(P), 123)));
      R.Assign(  2,  2, 15,  3);
        Insert(New(PLabel, Init( R, '~T~ext to find', P)));
      R.Assign( 16,  4, 49,  5);
        P:=Insert(New(PInputLine, Init( R ,255)));
      R.Assign( 49,  4, 52,  5);
        Insert(New(PHistory, Init( R, PInputLine(P), 124)));
      R.Assign(  6,  4, 15,  5);
        Insert(New(PLabel, Init( R, '~N~ew text', P)));
      R.Assign(  3,  7, 27, 11);
        P:=Insert(New(PCheckBoxes, Init( R,
                  NewSItem('~C~ase sensitive',
                  NewSItem('~W~hole words only',
                  NewSItem('~R~egular expression',
                  NewSItem('~P~rompt on replace',
                  nil)))))));
      R.Assign(  2,  6, 21,  7);
        Insert(New(PLabel, Init( R ,'Options', P)));
      R.Assign(  3, 13, 27, 15);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('~G~lobal',
                  NewSItem('~S~elected text',
                  nil)))));
      R.Assign(  2, 12, 21, 13);
        Insert(New(PLabel, Init( R ,'Scope', P)));
      R.Assign( 30,  7, 52,  9);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('Forwar~d~',
                  NewSItem('~B~ackward',
                  nil)))));
      R.Assign( 29,  6, 48,  7);
        Insert(New(PLabel, Init( R ,'Direction', P)));
      R.Assign( 30, 13, 52, 15);
        P:=Insert(New(PRadioButtons, Init( R ,
                  NewSItem('~F~rom cursor',
                  NewSItem('~E~ntire scope',
                  nil)))));
      R.Assign( 29, 12, 48, 13);
        Insert(New(PLabel, Init( R ,'Origin', P)));
      R.Assign(  2, 16, 12, 18);
        Insert(New(PButton, Init( R , '~~', cmOK, bfDefault)));
      R.Assign( 14, 16, 29, 18);
        Insert(New(PButton, Init( R , strChangeAll, cmYes, bfNormal)));
      R.Assign( 30, 16, 40, 18);
        Insert(New(PButton, Init( R , '⬥', cmCancel, bfNormal)));
      R.Assign( 42, 16, 52, 18);
        Insert(New(PButton, Init( R , '~~', cmHelp, bfNormal)));
      SelectNext(false);
   end;
   StdEditorReplaseDlg:=ReplaseForm;
end;
end.
