{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       FreePacal                                       }
{       Delphi 4                                        }
{       Turbo Vision Unit                               }
{       Extended visual components                      }
{                                                       }
{       Copyright (c) 1995-98 by Alexs                  }
{                                                       }
{*******************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}
unit TVForms;
interface

uses Dialogs, Objects, Views, Drivers, Clases, Ext_Type, Register;

type
  TCloseAction = (caNone, caHide, caFree, caMinimize);
type
  PForm = ^TForm;
  TCloseEvent = procedure(Sender: PForm; var Action: TCloseAction);
  TForm = object(TDialog)
     constructor Init(var Bounds: TRect; ATitle: TTitleStr);
     constructor Load(var S:TStream);
     procedure Store(var S:TStream);
     procedure SizeLimits(var Min,Max: TPoint); virtual;
     function ShowModal:word;virtual;
     function Show:PView;virtual;
     procedure Close;virtual;
     procedure Minimize;virtual;
  public
     OnClose: TCloseEvent;
  end;

const
  RForm: TStreamRec = (
    ObjType: rcForm;
    VmtLink: Ofs(TypeOf(TForm)^);
    Load: @TForm.Load;
    Store: @TForm.Store);

implementation
uses App;

 { TForm }
constructor TForm.Init(var Bounds: TRect; ATitle: TTitleStr);
begin
  inherited Init( Bounds, ATitle);
  Palette:=dpBlueDialog;
  GrowMode := gfGrowAll + gfGrowRel;
  Flags := wfMove + wfGrow + wfClose + wfZoom;
  Options := Options or ofTileable;
end;

procedure TForm.SizeLimits(var Min,Max: TPoint);
begin
  inherited SizeLimits( Min, Max);
  Min.X:=Length(Title^)+10;
end;

procedure TForm.Minimize;
var R:TRect;
begin
  SizeLimits(R.B, R.A);
  R.A.X:=Origin.X;
  R.A.Y:=Origin.Y;
  R.B.X:=Origin.X+R.B.X;
  R.B.Y:=Origin.Y+R.B.Y;
  ChangeBounds(R);
end;

function TForm.ShowModal:word;
begin
  ShowModal:=Desktop^.ExecView(@Self);
end;

function TForm.Show:PView;
begin
  if Owner=nil then Show:=Application^.InsertWindow(@Self)
  else TView.Show;
end;

procedure TForm.Close;
var
  CloseAction: TCloseAction;
begin
  if Assigned(OnClose) then
  begin
    CloseAction:=caFree;
    OnClose(@Self, CloseAction);
    case CloseAction of
      caHide:Hide;
      caMinimize:Minimize;
      caFree:if Valid(cmClose) then Free;
    end;
  end
  else inherited Close;
end;

constructor TForm.Load(var S:TStream);
begin
  inherited Load(S);
{$IFDEF VER70}
  LoadProcedure(S,@OnClose);
{$ENDIF}
end;

procedure TForm.Store(var S:TStream);
begin
  inherited Store(S);
{$IFDEF VER70}
  StoreProcedure(S,@OnClose);
{$ENDIF}
end;

end.
