const
  DBCNameLen = 263;

type
   TDateUpdate = packed record
      Y,M,D:byte;
   end;
type
   TFieldHeader2 = packed record       {16}
      FiName:array [1..11] of char;
      FiType:char;             {  C/N/L}
      FiLength:byte;           { 祭 }
      FiOfs:TrueWord;              {饭   }
      FiDecimals:byte;         { p ᫥ 窨}
   end;

   PFieldList2 = ^TFieldList2;
   TFieldList2 = array [0..(520-SizeOf(TFieldHeader2)) div SizeOf(TFieldHeader2)] of TFieldHeader2;

   PFileHeader2 = ^TFileHeader2;
   TFileHeader2 = packed record        { ࠧ  8  }
      Version:byte;             { 02h - dBase-II }
      RecordCount:TrueWord;         { ᫮ ᥩ  䠩}
      DateUpdate:TDateUpdate;   {  ᫥ 䨪樨}
      RecordSize:TrueWord;          { p  }
      Fields:TFieldList2;
      HeaderEnd:byte;
   end;


type
   PFileHeader3 = ^TFileHeader3;
   TFileHeader3 = packed record        { ࠧ  32  }
      Version:byte;            { 03h - dBase-III }
                               { 83h - dBase-III   .DBT 䠩}
                               { F5h - Foxpro DBF + Foxpro memo}
      DateUpdate:TDateUpdate;  {  ᫥ 䨪樨}
      RecordCount:longint;    { ᫮ ᥩ  䠩}
      HeaderSize:TrueWord;         { 騩 ࠧ  }
      RecordSize:TrueWord;         { p  }
      case byte of
{3} 03: ( Ignored:array [1..20] of byte);
{4} 04: ( Reserved1:TrueWord;
                TransCation:byte;
                Privated:boolean;
                ReservedNet: array [1..12] of byte;
                Status:byte;
                LanguageDriver:byte;
                Reserved2: array [1..2] of byte);
   end;

   TFieldHeader3 = packed record       {32}
      FiName:array [1..11] of char;
      FiType:char;             {  C/N/D/L/M} {DATA - YYYYMMDD}
      FiOfs:TrueWord;              {饭   }
      ig:TrueWord;
      FiLength:byte;           { 祭 }
      FiDecimals:byte;         { p ᫥ 窨}
      Ignored:array [1..14] of byte;
   end;

   PFieldList3 = ^TFieldList3;
   TFieldList3 = array [0..65480 div SizeOf(TFieldHeader3)] of TFieldHeader3;

type
   PFileHeader7 = ^TFileHeader7;
   TFileHeader7 = packed record        { ࠧ  48  }
      Version:byte;             { 04h - dBase-7 }
      DateUpdate:TDateUpdate;   {  ᫥ 䨪樨}
      RecordCount:longint;      { ᫮ ᥩ  䠩}
      HeaderSize:TrueWord;          { 騩 ࠧ  }
      RecordSize:TrueWord;          { p  }
      Reserved1:TrueWord;
      TransCation:byte;
      Privated:boolean;
      ReservedNet: array [1..12] of byte;
      MDX:boolean;
      LanguageDriver:byte;
      Reserved2: array [1..2] of byte;
      LangDrvName:array[1..36] of char;
   end;

   TFieldHeader7 = packed record       {32}
      FiName: array [1..32] of char;
      FiType:char;             {  C/N/D/L/M} {DATA - YYYYMMDD}
      FiLength:byte;           { 祭 }
      FiDecimals:byte;         { p ᫥ 窨}
      FiOfs:TrueWord;              {饭   }
      Ignored:array [1..11] of byte;
   end;

   PFieldList7 = ^TFieldList7;
   TFieldList7 = array [0..65480 div SizeOf(TFieldHeader7)] of TFieldHeader7;

procedure DisposeHeader(var Header:PDBaseHeader);
var i:integer;
begin
  if Header<>nil then
  begin
    for i:=0 to Header^.FieldCount-1 do DisposeStr(Header^.Fields^[i].Name);
    FreeMem(Header^.Fields, Header^.FieldCount*SizeOf(TFieldRecord));
    if Header^.TableLanguage<>nil then DisposeStr(Header^.TableLanguage);
    Dispose(Header);
    Header:=nil;
  end;
end;

procedure ReadDBase3Header(S:PStream; var Header:PDBaseHeader);{$IFNDEF FPC}far;{$ENDIF}
var DBaseHeader3:TFileHeader3;
    FieldList:PFieldList3;
    i,ofs:TrueWord;
    Pos,fCount:integer;
    P:PChar;
    FieldRec:TFieldHeader3;
    C:char  absolute FieldRec;
begin
  if S=nil then exit;
  with S^ do
  begin
    Flush;
    Seek(0);
    Read(DBaseHeader3, SizeOf(TFileHeader3));
    if Header=nil then New(Header);
    FillChar(Header^, SizeOf(TDBaseHeader), 0);

    Header^.Version:=DBaseHeader3.Version;
    with DBaseHeader3.DateUpdate do
      Header^.LastUpdate:=EncodeDate(1900+Y,M,D);
    Header^.RecordCount:=DBaseHeader3.RecordCount;
    Header^.HeaderSize:=DBaseHeader3.HeaderSize;
    Header^.RecordSize:=DBaseHeader3.RecordSize;
    Header^.LanguageDriver:=DBaseHeader3.LanguageDriver;
    Header^.MemoFile:=DBaseHeader3.Version in [$83,$F5];
    Header^.MDX:=(DBaseHeader3.Status and $01) <> 0;
    if Header^.Version=verVFP then
    begin
      Header^.MemoFile:=(DBaseHeader3.Status and $02) <> 0;
      Header^.isDataBase:=(DBaseHeader3.Status and $04) <> 0;
    end
    else Header^.MemoFile:=(Header^.Version and $C0)<>0;
    Header^.FieldCount:=0;
    Pos:=GetPos;
    {⠥  }
    {fCount:=(DBaseHeader3.HeaderSize-SizeOf(TFileHeader3)-1) div SizeOf(TFieldHeader3);}
    repeat
      Read( C, SizeOf(Char));
      if C<>#$0D then
      begin
        Read(FieldRec, SizeOf(TFieldHeader3)-SizeOf(Char));
        inc(Header^.FieldCount);
      end;
    until (FieldRec.FiName[1]=#$0D){ or (Header^.FieldCount>=fCount)} or (S^.Status<>stOk);
    Seek(Pos);
    GetMem(FieldList, SizeOf(TFieldHeader3)*Header^.FieldCount);
    Read(FieldList^, SizeOf(TFieldHeader3)*Header^.FieldCount);
    { Visual FoxPro ⠥  DBC 䠩}
    if Header^.Version=verVFP then
    begin
      Seek(GetPos+1);
      GetMem(P, DBCNameLen);
      Read(P^, DBCNameLen);
      Header^.DBCName:=NewStr(StrPas(P));
      FreeMem(P, DBCNameLen);
    end;
    GetMem(Header^.Fields, SizeOf(TFieldRecord)*Header^.FieldCount);
    FillChar(Header^.Fields^, SizeOf(TFieldRecord)*Header^.FieldCount, 0);
    Ofs:=1;
    for i:=0 to Header^.FieldCount-1 do
    with Header^.Fields^[i] do
    begin
      Name:=NewStr(StrPas(@(FieldList^[i].FiName)));
      fType:=FieldList^[i].FiType;
      fLength:=FieldList^[i].FiLength;
      fDecimal:=FieldList^[i].FiDecimals;
      fOffset:=Ofs;
      inc(Ofs,fLength);
    end;
    FreeMem(FieldList, SizeOf(TFieldHeader3)*Header^.FieldCount);
  end;
end;

procedure WriteDBase3Header(S:PStream; Header:PDBaseHeader;
                            WriteFields:boolean);{$IFNDEF FPC}far;{$ENDIF}
var DBaseHeader3:TFileHeader3;
    i:TrueWord;
    Year, Month, Day: Word;
    CurDate:TDateTime;
    FieldRec:TFieldHeader3;
    C:char;
    P:Pointer;
begin
  with S^ do
  begin
    if Header^.HeaderSize=0 then
       Header^.HeaderSize:=SizeOf(TFileHeader3)+
                Header^.FieldCount*SizeOf(TFieldHeader3)+1;
    Seek(0);
    FillChar(DBaseHeader3, SizeOf(TFileHeader3), 0);
    DBaseHeader3.Version:=Header^.Version;;
    with DBaseHeader3.DateUpdate do
    begin
      CurDate:=Now;
      DecodeDate(CurDate, Year, Month, Day);
      Y:=Year-1900;
      M:=Month;
      D:=Day;
      Header^.LastUpdate:=CurDate;
    end;
    DBaseHeader3.RecordCount:=Header^.RecordCount;
    DBaseHeader3.HeaderSize:=Header^.HeaderSize;
    DBaseHeader3.RecordSize:=Header^.RecordSize;
    DBaseHeader3.LanguageDriver:=Header^.LanguageDriver;
    DBaseHeader3.Status:=ord(Header^.MDX) or
      (ord((Header^.Version=verVFP) and Header^.MemoFile) shl 1) or
      (ord((Header^.Version=verVFP) and Header^.isDataBase) shl 2);
    Write(DBaseHeader3, SizeOf(TFileHeader3));
    if WriteFields then
    begin
      for i:=0 to Header^.FieldCount-1 do
      begin
        FillChar(FieldRec, SizeOf(TFieldHeader3),0);
        move(Header^.Fields^[i].Name^[1],FieldRec.FiName, min(Length(Header^.Fields^[i].Name^),10));
        FieldRec.FiType:=Header^.Fields^[i].fType;
        FieldRec.FiOfs:=Header^.Fields^[i].fOffset;
        FieldRec.FiLength:=Header^.Fields^[i].fLength;
        FieldRec.FiDecimals:=Header^.Fields^[i].fDecimal;
        Write(FieldRec, SizeOf(TFieldHeader3));
      end;
      C:=#$0D;
      Write(C, SizeOf(Char));
      if Header^.Version=verVFP then
      begin
        GetMem(P, DBCNameLen);
        FillChar(P^, DBCNameLen, 0);
        if Header^.DBCName<>nil then
          Move(Header^.DBCName^[1], P^, Length(Header^.DBCName^));
        Write(P^, DBCNameLen);
        FreeMem(P, DBCNameLen);
      end;
    end;
  end;
end;

procedure ReadDBase7Header(S:PStream; var Header:PDBaseHeader);{$IFNDEF FPC}far;{$ENDIF}
var DBaseHeader7:TFileHeader7;
    FieldList:PFieldList7;
    i,ofs:TrueWord;
begin
  if S=nil then exit;
  with S^ do
  begin
    Seek(0);
    Read(DBaseHeader7, SizeOf(TFileHeader7));
    if Header=nil then New(Header);
    FillChar(Header^, SizeOf(TDBaseHeader), 0);
    Header^.Version:=DBaseHeader7.Version;
    with DBaseHeader7.DateUpdate do
    Header^.LastUpdate:=EncodeDate(1900+Y,M,D);
    Header^.RecordCount:=DBaseHeader7.RecordCount;
    Header^.HeaderSize:=DBaseHeader7.HeaderSize;
    Header^.RecordSize:=DBaseHeader7.RecordSize;
    Header^.FieldCount:=(DBaseHeader7.HeaderSize-SizeOf(TFileHeader7)-1) div SizeOf(TFieldHeader7);
    Header^.MemoFile:=DBaseHeader7.Version in [$F5];
    Header^.TableLanguage:=NewStr(StrPas(@(DBaseHeader7.LangDrvName)));
    GetMem(Header^.Fields, SizeOf(TFieldRecord)*Header^.FieldCount);
    FillChar(Header^.Fields^, SizeOf(TFieldRecord)*Header^.FieldCount, 0);
    GetMem(FieldList, SizeOf(TFieldHeader7)*Header^.FieldCount);
    Read(FieldList^, SizeOf(TFieldHeader7)*Header^.FieldCount);
    Ofs:=1;
    for i:=0 to Header^.FieldCount-1 do
    with Header^.Fields^[i] do
    begin
      Name:=NewStr(StrPas(@(FieldList^[i].FiName)));
      fType:=FieldList^[i].FiType;
      fLength:=FieldList^[i].FiLength;
      fDecimal:=FieldList^[i].FiDecimals;
      fOffset:=Ofs;
      inc(Ofs,fLength);
    end;
    FreeMem(FieldList, SizeOf(TFieldHeader7)*Header^.FieldCount);
  end;
end;

procedure WriteDBase7Header(S:PStream; Header:PDBaseHeader; WriteFields:boolean);{$IFNDEF FPC}far;{$ENDIF}
begin
  abstract;
end;

procedure ReadDBase2Header(S:PStream; var Header:PDBaseHeader);{$IFNDEF FPC}far;{$ENDIF}
var DBaseHeader2:TFileHeader2;
    FieldList:PFieldList2;
    i,ofs:TrueWord;
begin
  if S=nil then exit;
  with S^ do
  begin
    Seek(0);
    Read(DBaseHeader2, SizeOf(TFileHeader2));
    if Header=nil then New(Header);
    FillChar(Header^, SizeOf(TDBaseHeader), 0);
    Header^.Version:=DBaseHeader2.Version;
    with DBaseHeader2.DateUpdate do
    Header^.LastUpdate:=EncodeDate(1900+Y,M,D);
    Header^.RecordCount:=DBaseHeader2.RecordCount;
    Header^.RecordSize:=DBaseHeader2.RecordSize;
    FieldList:=@DBaseHeader2.Fields;
    i:=0; while FieldList^[i].FiName[1]<>#$0D do inc(i);
    Header^.HeaderSize:=521;
    Header^.FieldCount:=i;
    GetMem(Header^.Fields, SizeOf(TFieldRecord)*Header^.FieldCount);
    FillChar(Header^.Fields^, SizeOf(TFieldRecord)*Header^.FieldCount, 0);
    Ofs:=1;
    for i:=0 to Header^.FieldCount - 1 do
    with Header^.Fields^[i] do
    begin
      Name:=NewStr(StrPas(@(FieldList^[i].FiName)));
      fType:=FieldList^[i].FiType;
      fLength:=FieldList^[i].FiLength;
      fDecimal:=FieldList^[i].FiDecimals;
      fOffset:=Ofs;
      inc(Ofs,fLength);
    end;
  end;
end;

procedure WriteDBase2Header(S:PStream; Header:PDBaseHeader; WriteFields:boolean);{$IFNDEF FPC}far;{$ENDIF}
var DBaseHeader2:TFileHeader2;
    FieldList:PFieldList2;
    i:TrueWord;
    Year, Month, Day: Word;
    CurDate:TDateTime;
begin
  if S=nil then exit;
  with S^ do
  begin
    Seek(0);
    FillChar(DBaseHeader2, SizeOf(TFileHeader2), 0);
    DBaseHeader2.Version:=$02;
    with DBaseHeader2.DateUpdate do
    begin
      CurDate:=Now;
      DecodeDate(CurDate, Year, Month, Day);
      Y:=Year-1900;
      M:=Month;
      D:=Day;
      Header^.LastUpdate:=CurDate;
    end;
    DBaseHeader2.RecordCount:=Header^.RecordCount;
    DBaseHeader2.RecordSize:=Header^.RecordSize;
    Write(DBaseHeader2, 8);
    if WriteFields then
    begin
      FieldList:=@DBaseHeader2.Fields;
      for i:=0 to Min(Header^.FieldCount-1, 30) do
      begin
        Move(FieldList^[i].FiName, Header^.Fields^[i].Name^[1], Min(Length(Header^.Fields^[i].Name^),10));
        FieldList^[i].FiType:=Header^.Fields^[i].fType;
        FieldList^[i].FiLength:=Header^.Fields^[i].fLength;
        FieldList^[i].FiDecimals:=Header^.Fields^[i].fDecimal;
      end;
      FieldList^[Min(Header^.FieldCount, 31)].FiName[1]:=#$0D;
      write(FieldList^, SizeOf(TFieldHeader2)*Header^.FieldCount+1);
    end;
  end;
end;
