{************************************************}
{                                                }
{   Extended string functions                    }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O-}
{$ENDIF}
{$I Define.inc}
unit Ext_Str;

interface
uses Ext_Type, Objects;

const
  wtUnknow  = 0;
  wtInteger = 1;
  wtReal    = 2;
  wtString  = 3;
const
{$IFDEF LINUX}
  cEoL      = #10;
{$ELSE}
  cEoL      = #13#10;
{$ENDIF}

type
  TNumStr       = string[15];

function DupChar( AChar:Char; ACount:byte):string;
function CountChar(var Buf; Len:word; TestChar:char):word;
function FindChar(var Buf; Len:word; TestChar:char):word;

function chDosToWin(C:Char):Char;
function chWinToDos(C:Char):Char;
function stDosToWin(S:string):string;
function stWinToDos(S:string):string;
procedure bufDosToWin(var Buf; Count:word);
procedure bufWinToDos(var Buf; Count:word);

function ChLoCase(C: Char) : Char;
function ChUpCase(C: Char) : Char;

function StLoCase(const S : string) : string;
function StUpCase(const S : string) : string;
function AnsiUpperCase(const S : string) : string;
{$IFDEF VER70}
function chUniToDos(C:WideChar):Char;
{$ENDIF}
procedure UniConvBuf(var Sours,Dest; Len:integer);

procedure FillSpace(var S:string; Count:byte);
function FillSpaceA(S:string; Count:byte):string;
function TrimLeft(s:string):string;
function TrimRight(s:string):string;
function Trim(S:string):string;
function Compare(S1,S2:string):integer;
function ASCIICompare(S1,S2:string):integer;
function AnsiCompareText(S1,S2:string):integer;

procedure AssignStr(var P:PString; const S:string);
function DinamicStr(P:PString):string;
function IsHotKey(EvChar, HotChar: char): boolean;
function HotKey(const S: String): Char;
{$IFDEF VER70}
procedure SetLength(var S:string; Len:integer);
{$ENDIF}

function NextWord(const S:string;var i:integer):string;
function ParseString(var S:String; Len:byte):string;
function CheckNum(const S:TNumStr):boolean;
function CheckIdentificator(const S:string):boolean;
function MakeAlign(Align:TAlign; S:string; Len:integer):string;
function WordType(S:String):byte;
function AddQuete(const S:string):string;
function DelQuete(const S:string):string;
function NameCase(S:string):string;

            {Quote}
{$IFNDEF UseDrivers}
procedure FormatStr(var Result: String; const Format: string; var Params);
{$ENDIF}
const
  WordChars: set of Char = ['0'..'9', 'A'..'Z', '_', 'a'..'z',
                            ''..'',''..'','',''];
  Digit = ['0'..'9'];


implementation
uses Ext_Math;

function DinamicStr(P:PString):string;
begin
  if P<>nil then DinamicStr:=P^ else DinamicStr:='';
end;

{$IFDEF VER70}
function TrimLeft(s:string):string;assembler;
asm
        PUSH DS
        CLD      {㤥 ।  אַ ࠢ}
        LDS SI,S
        LES DI,@Result
        XOR AX,AX
        LODSB
        MOV CX,AX
        JCXZ @@2
@@1:    LODSB
        CMP AL,32
        JA @@2
        LOOP @@1
@@2:    MOV AL,CL
        STOSB
        JCXZ @End
        DEC SI
    REP MOVSB
@END:
        POP DS
end;

function TrimRight(s:string):string;assembler;
asm
        PUSH DS
        STD      {㤥 ।  אַ ࠢ}
        LDS SI,S
        LES DI,@Result
        XOR AX,AX
        MOV AL,DS:[SI]
        MOV CX,AX
        JCXZ @@2
        ADD SI,AX
@@1:    LODSB
        CMP AL,32
        JA @@2
        LOOP @@1
@@2:    MOV AL,CL
        CLD      {㤥 ।  אַ ࠢ}
        STOSB
        JCXZ @END
        LDS SI,S
        INC SI
    REP MOVSB
@END:
        POP DS
end;

function Trim(S:string):string;
begin
  Trim:=TrimLeft(TrimRight(S));
end;
{$ELSE}
function Trim(S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
end;

function TrimLeft(S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  Result := Copy(S, I, Maxint);
end;

function TrimRight(S: string): string;
var
  I: Integer;
begin
  I := Length(S);
  while (I > 0) and (S[I] <= ' ') do Dec(I);
  Result := Copy(S, 1, I);
end;
{$ENDIF}

{$IFDEF VER70}
procedure SetLength(var S:string; Len:integer);
begin
  byte(S[0]):=Len;
end;

procedure UpcasePrim; far; assembler;
{ Entry : character to upcase in AL }
{ Exit  : uppercase in AL }
asm
        CMP     AL,'a'
        JB      @UpCaseDone             { Done if AL < 'a' }
        CMP     AL,''
        JA      @Cont          {@UpCaseDone}{ Done if AL > '' }
        CMP     AL,'z'
        JA      @ExtUpCase              { Jump if extended uppercase }
        SUB     AL,32                   { Convert to uppercase }
        JMP     @UpCaseDone
@Cont:
        CMP     AL,''
        JNE     @UpCaseDone
        MOV     AL,''
        JMP     @UpCaseDone

@ExtUpCase:                             { Russion uppercase }
        CMP     AL,160
        JB      @UpCaseDone
        CMP     AL,176
        JB      @Done                   {  AL < 176 }
        CMP     AL,224
        JB      @UpCaseDone             { Done if AL < 224 }
        SUB     AL,48
@Done:
        SUB     AL,32
@UpCaseDone:
end;

function ChUpCase(C: Char) : Char; assembler;
{ Return uppercase of char, with russion character support }
asm
        MOV     AL, C           { AL = input character }
        CALL    UpcasePrim
end;

procedure LoCasePrim; far; assembler;

{ Entry : character to locase in AL }
{ Exit  : lowercase in AL }

asm
        CMP     AL,'A'
        JB      @LoCaseDone             { Done if AL < 'A' }
        CMP     AL,''
        JA      @LoCaseDone             { Done if AL > '' }
        CMP     AL,'Z'
        JA      @ExtLoCase              { Jump if extended lowercase }
        ADD     AL,32                   { Convert to lowercase }

@ExtLoCase:                             { russion lowercase }
        CMP     AL,127
        JB      @LoCaseDone             { Done if AL < #127 }
        CMP     AL,''                  {  AL < '' }
        JB      @Done
        ADD     AL,48

@Done:
        ADD     AL,32
        RET
@LoCaseDone:
end;

function ChLoCase(C: Char) : Char; assembler;
{ Return lowercase of char, with russion character support }
asm
        MOV     AL, C                   { AL = input character }
        CALL    LoCasePrim              { Lowercase }
end;

procedure StCase; far; assembler;
{ Convert string to one case or another, depending on DX }
{ input ES:DI => function result }
asm
        CLD                             { go forward }
        LODSB                           { AL = Length(S) }
        STOSB                           { Set length of result }
        XOR     CH, CH                  { CH = 0 }
        MOV     CL,AL                   { CX = Length(S) }
        JCXZ    @Done                   { Done if CX is 0 }
@NextChar:
        LODSB                           { Next char into AL }
        PUSH    CS                      { Fake a FAR CALL }
        CALL    DX                      { Uppercase it }
        STOSB                           { Store char in result }
        LOOP    @NextChar               { repeat }
@Done:

end;

function StUpCase(const S : string) : string;  assembler;
{ Convert lower case letters in string to upper case }

asm
        PUSH    DS
        MOV     DX,OFFSET UpcasePrim
        LES     DI,@Result              { ES:DI => function result }
        LDS     SI,S                    { DS:SI => S }
        CALL    StCase
        POP     DS
end;

function StLoCase(const S : string) : string; assembler;
{ Convert upper case letters in string to lower case }
asm
        PUSH    DS
        MOV     DX,OFFSET LoCasePrim
        LDS     SI,S                    { DS:SI => S }
        LES     DI,@Result              { ES:DI => function result }
        CALL    StCase
        POP     DS
end;

{**********************************************************************}
{ 㭪  ᨢ ப   ACount ᨬ AChar }
{**********************************************************************}
function DupChar( AChar:Char; ACount:byte):string;assembler;
asm
        PUSH    DS
        LES     DI,@Result        { ES:DI => function result }
        MOV     AL,ACount
        XOR     AH,AH
        STOSB
        MOV     CX,AX
        MOV     AL,AChar
    REP STOSB
        POP     DS
end;

{**************************************************************************}
{ 㭪 ⠥ ᫮ 宦 ᨬ TestChar   Buf  Len}
{**************************************************************************}
function CountChar(var Buf; Len:word; TestChar:char):word;assembler;
asm
        PUSH    DS
        LDS     SI,Buf
        MOV     CX,Len
        XOR     BX,BX
@@1:    LODSB
        CMP     AL,TestChar
        JNZ     @@2
        INC     BX
@@2:    LOOP    @@1
        POP     DS
        MOV     AX,BX
end;

function FindChar(var Buf; Len:word; TestChar:char):word;assembler;
asm
        LES     DI,Buf
        CLD            {᪠஢ 㤥  אַ ࠢ}
        MOV     CX,Len
        MOV     AL,TestChar
  REPNE SCASB            {ࠢ 'A'  । ⮬}
        JNZ     @@1
        MOV     AX,Len
        SUB     AX,CX
        JMP     @@End
@@1:    XOR     AX,AX
@@End:
end;
{$ELSE}

function ChUpCase(C: Char) : Char;
begin
  if C in ['a'..'z',''..''] then ChUpCase:=Char(Byte(C)-32)
  else
  if C in [''..''] then ChUpCase:=Char(Byte(C)-32-48)
  else
  if C='' then ChUpCase:=''
  else ChUpCase:=C;
end;

function ChLoCase(C: Char) : Char;
begin
  if C in ['A'..'Z',''..''] then ChLoCase:=Char(Byte(C)+32)
  else
  if C in [''..''] then ChLoCase:=Char(Byte(C)+32+48)
  else
  if C='' then ChLoCase:=''
  else ChLoCase:=C;
end;

function StUpCase(const S : string) : string;
var i:integer;
begin
  Result:='';
  for i:=1 to Length(S) do Result:=Result+chUpCase(S[i]);
end;

function StLoCase(const S : string) : string;
var i:integer;
begin
  Result:='';
  for i:=1 to Length(S) do Result:=Result+chLoCase(S[i]);
end;

function DupChar( AChar:Char; ACount:byte):string;
var S:string;
    i:integer;
begin
  s:='';
  for i:=1 to ACount do S:=S+AChar;
  DupChar:=S;
end;

function CountChar(var Buf; Len:word; TestChar:char):word;
var i,C:integer;
    ABuf:TCharArray absolute Buf;
begin
  C:=0;
  for i:=0 to Len-1 do
    if ABuf[i]=TestChar then inc(C);
  CountChar:=C;
end;

function FindChar(var Buf; Len:word; TestChar:char):word;
var i:integer;
    ABuf:TCharArray absolute Buf;
begin
  FindChar:=0;
  for i:=0 to Len-1 do
    if ABuf[i]=TestChar then
    begin
      FindChar:=i;
      exit;
    end;
end;
{$ENDIF}


procedure AssignStr(var P:PString; const S:string);
begin
  if P<>nil then DisposeStr(P);
  P:=NewStr(S);
end;

{$IFDEF VER70}
procedure DosToWinPrim;near;assembler;
{in  AL - char win code}
{out AL - char dos code}
asm
        CMP     AL,128
        JB      @End
        CMP     AL,239
        JA      @End
        CMP     AL,176
        JB      @1st
        CMP     AL,224
        JB      @End
        JMP     @2nd
@1st:
        ADD     AL,48
@2nd:
        ADD     AL,16
@End:
end;

function chDosToWin(C:Char):Char;assembler;
asm
  MOV AL,C
  CALL DosToWinPrim
end;

procedure WinToDosPrim;near;assembler;
{in  AL - char win code}
{out AL - char dos code}
asm
  CMP AL,192
  JB @End
  SUB AL,16
  CMP AL,224
  JAE @End
  SUB AL,48
@End:
end;

function chWinToDos(C:Char):Char;assembler;
asm
  MOV AL,C
  CALL WinToDosPrim
end;

procedure bufDosToWin(var Buf; Count:word);assembler;
asm
        PUSH    DS
        MOV     CX,Count
        AND     CX,CX
        JZ      @@End
        LDS     SI,Buf
        LES     DI,Buf
@@1:    LODSB
        CALL    DosToWinPrim
        STOSB
        LOOP    @@1
@@End:
        POP     DS
end;

procedure bufWinToDos(var Buf; Count:word);assembler;
asm
        PUSH    DS
        MOV     CX,Count
        AND     CX,CX
        JZ      @@End
        LDS     SI,Buf
        LES     DI,Buf
@@1:    LODSB
        CALL    WinToDosPrim
        STOSB
        LOOP    @@1
@@End:
        POP     DS
end;
{$ELSE}
function chDosToWin(C:Char):Char;
begin
  chDosToWin:=C;
end;

function chWinToDos(C:Char):Char;
begin
  if (C>#192) and (C<#240) then chWinToDos:=char(byte(C)-16-48)
  else
  if (C>=#240) then chWinToDos:=char(byte(C)-16)
  else chWinToDos:=C;
end;

procedure bufDosToWin(var Buf; Count:word);
var ABuf:TCharArray absolute Buf;
    I:integer;
begin
  for i:=0 to Count-1 do
    ABuf[i]:=chDosToWin(ABuf[i]);
end;

procedure bufWinToDos(var Buf; Count:word);
var ABuf:TCharArray absolute Buf;
    I:integer;
begin
  for i:=0 to Count-1 do
    ABuf[i]:=chWinToDos(ABuf[i]);
end;
{$ENDIF}

function stDosToWin(S:string):string;
var I:integer;
begin
  for i:=1 to length(S) do
      S[i]:=chDosToWin(S[i]);
  stDosToWin:=S;
end;

function stWinToDos(S:string):string;
var I:integer;
begin
  for i:=1 to length(S) do
      S[i]:=chWinToDos(S[i]);
  stWinToDos:=S;
end;

function IsHotKey(EvChar, HotChar: char): boolean;
{var
  IsHot: boolean;}
const
  Cyr: array ['A'..'Z'] of char = '';
begin
  EvChar:=chUpCase(EvChar);
  HotChar:=chUpCase(HotChar);
  IsHotKey:=(EvChar = HotChar) or
    ((EvChar in ['A'..'Z']) and (Cyr[EvChar] = HotChar)) or
    (HotChar = '') and (EvChar = '[') or
    (HotChar = '') and (EvChar = ']') or
    (HotChar = '') and (EvChar = ';') or
    (HotChar = '') and (EvChar = '''') or
    (HotChar = '') and (EvChar = ',') or
    (HotChar = '') and (EvChar = '.') or
    (HotChar = '') and ((EvChar = '`') or (EvChar = '/'))
end;

procedure FillSpace(var S:string; Count:byte);
begin
  S:=FillSpaceA(S,Count);
end;

function FillSpaceA(S:string; Count:byte):string;
begin
  if Length(S)>=Count then FillSpaceA:=Copy(S,1,Count)
  else FillSpaceA:=S+DupChar(' ',Count-Length(S))
end;

function ParseString(var S:String; Len:byte):string;
var i:byte;
begin
  if Length(S)<len then
  begin
    ParseString:=S;
    S:='';
    exit;
  end;
  for i:=len+1 downto 1 do
      if not (s[i] in WordChars) then break;
  if i=1 then i:=Len;
  ParseString:=Copy(S, 1, i);
  Delete(S,1,i);
end;

function NextWord(const S:string;var i:integer):string;
begin
  while (i<length(s)) and not (s[i] in WordChars) do inc(i);
  while (i<length(s)) and (s[i] in WordChars) do inc(i);
{  if i>0 then dec(i);}
  NextWord:=Copy(S,1,i-1);
end;

function HotKey(const S: String): Char;
var
  P: Word;
begin
  P := Pos('~',S);
  if P <> 0 then HotKey := chUpCase(S[P+1])
  else HotKey := #0;
end;

function CheckNum(const S:TNumStr):boolean;
{$IFNDEF VER70}
var i,Code: Longint;
{$ELSE}
var i,Code: integer;
{$ENDIF}
begin
  Val(TrimRight(S),i, Code);
  CheckNum:=Code=0;
end;

{$IFDEF VER70}
{ ᫨ S1>S2  Compare=1}
{ ᫨ S1<S2  Compare=-1}
{ ᫨ S1=S2  Compare=0}
function Compare(S1,S2:string):integer;assembler;
asm
        PUSH    DS
        CLD
        XOR     CX,CX
        LES     DI,S2
        LDS     SI,S1
        LODSB
        MOV     AH,ES:[DI]
        INC     DI
        CMP     AL,AH
        JB      @@1
        MOV     AL,AH
@@1:
        MOV     CL,AL
    REP CMPSB
        JNZ     @@2
        XOR     AX,AX
        JMP     @END
@@2:
        MOV     AX,1
        JA      @END
        NEG     AX
@END:
        POP     DS
end;

{ ᫨ S1>S2  Compare=1}
{ ᫨ S1<S2  Compare=-1}
{ ᫨ S1=S2  Compare=0}
function ASCIICompare(S1,S2:string):integer;assembler;
asm
        PUSH    DS
        CLD
        XOR     CX,CX
        LES     DI,S2
        LDS     SI,S1
        LODSB
        MOV     AH,ES:[DI]
        INC     DI
        CMP     AL,AH
        JB      @@1
        MOV     AL,AH
@@1:
        MOV     CL,AL
    REP CMPSB
        JNZ     @@2
        XOR     AX,AX
        JMP     @END
@@2:
        DEC     SI
        DEC     DI
        MOV     AL,ES:[DI]
        MOV     AH,DS:[SI]

        CMP     AH,''
        JNE     @@3
        CMP     AL,''
        MOV     AH,''
        JA      @@6
        INC     AH
        JMP     @@6

@@3:    CMP     AH,''
        JNE     @@4
        CMP     AL,''
        MOV     AH,''
        JA      @@6
        INC     AH
        JMP     @@6


@@4:    CMP     AL,''
        JNE     @@5
        CMP     AH,''
        MOV     AL,''
        JA      @@6
        INC     AL
        JMP     @@6

@@5:    CMP     AL,''
        JNE     @@6
        CMP     AH,''
        MOV     AL,''
        JA      @@6
        INC     AL

@@6:    CMP     AH,AL
        MOV     AX,1
        JA      @END
        NEG     AX
@END:
        POP     DS
end;

procedure UniConv;near;assembler;
{IN       AX - WideChar}
{OUT      AL - Char}
asm
        CMP     AH,$04
        JNE     @End
        ADD     AL,128-16
        CMP     AL,64+128-16
        JB      @End
        ADD     AL,48
@End:
end;

function chUniToDos(C:WideChar):Char;assembler;
asm
        MOV     AX,C
        CALL    UniConv
end;

procedure UniConvBuf(var Sours,Dest; Len:integer);assembler;
asm
        PUSH    DS
        LDS     SI,Sours
        LES     DI,Dest
        MOV     CX,Len
@@1:    LODSW
        CALL    UniConv
        STOSB
        LOOP    @@1
        POP     DS
end;
{$ELSE}

function Compare(S1,S2:string):integer;
begin
  if S1>S2 then Compare:=1
  else
  if S1<S2 then Compare:=-1
  else Compare:=0
end;

function ASCIICompare(S1,S2:string):integer;
begin
  ASCIICompare:=Compare(S1,S2);
end;

function chUniToDos(C:WideChar):Char;
begin
//  chUniToDos:=Char(Lo(C));
end;

procedure UniConvBuf(var Sours,Dest; Len:integer);
var Sourse:TWideCharArray absolute Sours;
    D:TCharArray absolute Dest;
    i:integer;
begin
//  for i:=0 to Len do D[i]:=chUniToDos(Sourse[i]);
end;
{$ENDIF}
function AnsiCompareText(S1,S2:string):integer;
begin
  AnsiCompareText:=ASCIICompare(S1,S2);
end;
function AnsiUpperCase(const S : string) : string;
begin
  AnsiUpperCase:=stUpCase(S);
end;
{$IFNDEF UseDrivers}
procedure FormatStr(var Result: String; const Format: string; var Params);
type
  TLongArray = Array[0..0] Of LongInt;
var
  ResultLength, FormatIndex, Justify, Wth: Byte; Fill: Char; S: String;

   function LongToStr (L: Longint; Radix: Byte): String;
   const
    HexChars: Array[0..15] Of Char =
    ('0', '1', '2', '3', '4', '5', '6', '7',
     '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
   var
     I: longInt;
     S: string;
     Sign: string[1];
   begin
     LongToStr := '';                                 { Preset empty return }
     If (L < 0) Then begin                            { If L is negative }
       Sign := '-';                                   { Sign is negative }
       L := Abs(L);                                   { Convert to positive }
     end Else Sign := '';                             { Sign is empty }
     S := '';                                         { Preset empty string }
     Repeat
       I := L mod Radix;                              { Radix mod of value }
       S := HexChars[I] + S;                          { Add char to string }
       L := L div Radix;                              { Divid by radix }
     Until (L = 0);                                   { Until no remainder }
     LongToStr := Sign + S;                           { Return result }
   end;

   procedure HandleParameter (I : LongInt);
   begin
     While (FormatIndex <= Length(Format)) do
     begin                                            { While length valid }
       While (Format[FormatIndex] <> '%') and         { Param char not found }
             (FormatIndex <= Length(Format)) do
       begin                                          { Length still valid }
         Result[ResultLength+1] := Format[FormatIndex]; { Transfer character }
         Inc(ResultLength);                           { One character added }
         Inc(FormatIndex);                            { Next param char }
       end;
       If (FormatIndex < Length(Format)) and          { Not last char and }
       (Format[FormatIndex] = '%') Then begin         { '%' char found }
         Fill := ' ';                                 { Default fill char }
         Justify := 0;                                { Default justify }
         Wth := 0;                                    { Default 0=no width }
         Inc(FormatIndex);                            { Next character }
         If (Format[FormatIndex] = '0') then Fill := '0';                               { Fill char to zero }
         If (Format[FormatIndex] = '-') Then begin    { Optional just char }
           Justify := 1;                              { Right justify }
           Inc(FormatIndex);                          { Next character }
         end;
         While ((FormatIndex <= Length(Format)) and   { Length still valid }
         (Format[FormatIndex] >= '0') and
         (Format[FormatIndex] <= '9')) Do begin       { Numeric character }
           Wth := Wth * 10;                           { Multiply x10 }
           Wth := Wth + Ord(Format[FormatIndex])-$30; { Add numeric value }
           Inc(FormatIndex);                          { Next character }
         end;
         If ((FormatIndex <= Length(Format)) and      { Length still valid }
         (Format[FormatIndex] = '#')) Then begin      { Parameter marker }
           Inc(FormatIndex);                          { Next character }
           HandleParameter(Wth);                      { Width is param idx }
         end;
         If (FormatIndex <= Length(Format)) Then begin{ Length still valid }
           Case Format[FormatIndex] Of
           '%': begin                               { Literal % }
             S := '%';
             Inc(FormatIndex);
             Move(S[1], Result[ResultLength+1], 1);
             Inc(ResultLength,Length(S));
             Continue;
           end;
           'c': S := Char(TLongArray(Params)[I]);  { Character parameter }
           'd': S := LongToStr(TLongArray(Params)[I],10);{ Decimal parameter }
           's': S := PString(TLongArray(Params)[I])^;{ String parameter }
           'x': S := LongToStr(TLongArray(Params)[I],16);{ Hex parameter }
           end;
           Inc(FormatIndex);                          { Next character }
           If (Wth > 0) Then begin                    { Width control active }
             If (Length(S) > Wth) Then begin          { We must shorten S }
               If (Justify=1) Then                    { Check right justify }
                 S := Copy(S, Length(S)-Wth+1, Wth)   { Take right side data }
                 Else S := Copy(S, 1, Wth);           { Take left side data }
             end Else begin                           { We must pad out S }
               If (Justify=1) Then                    { Right justify }
                 While (Length(S) < Wth) Do
                   S := S+Fill Else                   { Right justify fill }
                 While (Length(S) < Wth) Do
                   S := Fill + S;                     { Left justify fill }
             end;
           end;
           Move(S[1], Result[ResultLength+1],
             Length(S));                              { Move data to result }
           Inc(ResultLength,Length(S));               { Adj result length }
           Inc(I);
         end;
       end;
     end;
   end;

begin
   ResultLength := 0;                                 { Zero result length }
   FormatIndex := 1;                                  { Format index to 1 }
   HandleParameter(0);                                { Handle parameter }
   SetLength(Result,ResultLength);
{   Result[0] := Chr(ResultLength); }                   { Set string length }

end;
{$ENDIF}
function CheckIdentificator(const S:string):boolean;
var i:integer;
begin
  CheckIdentificator:=false;
  if chUpCase(S[1]) in ['_','A'..'Z'] then
  begin
     for i:=2 to Length(s) do
         if not (chUpCase(S[1]) in ['_','A'..'Z','0'..'9']) then
         exit;
     CheckIdentificator:=true;
  end;
end;

function MakeAlign(Align:TAlign; S:string; Len:integer):string;
begin
  case Align of
{     alLeft:MakeAlign:=Copy(TrimLeft(S),1,Len);}
     alLeft:MakeAlign:=Copy(S,1,Len);
     alCenter:
       if Length(s)<Len then MakeAlign:=DupChar(' ',(Len-Length(S)) div 2)+S
       else MakeAlign:=Copy( S, 1,Len);
     alRight:begin
             if Length(S)<Len then
                MakeAlign:=DupChar(' ',Len-Length(S))+S
             else MakeAlign:=Copy(S, 1, Len);
           end;
  else
     MakeAlign:=Copy(S, 1, Len);
  end;
end;

function WordType(S:String):byte;
var i:integer;
begin
  WordType:=wtUnknow;
  if S='' then exit;
  i:=1;
  while (s[i] in ['0'..'9']) and (i>=Length(s)) do
        inc(i);
  if i>=Length(s) then
  begin
    WordType:=wtInteger;
    exit;
  end;
  if s[i]='.' then
  begin
    inc(i);
    while (s[i] in ['0'..'9']) and (i=Length(s)) do
          inc(i);
    if i=Length(s) then
    begin
      WordType:=wtReal;
      exit;
    end;
  end;
  WordType:=wtString;
end;

function AddQuete(const S:string):string;
var R:string;
    i:integer;
    LoChars:boolean;
begin
  i:=1;
  R:='';
  LoChars:=false;
  while I<=Length(S) do
  begin
    if S[i]<' ' then
    begin
      if not LoChars then
      begin
        R:=R+'''';
        LoChars:=true;
      end;
      R:=R+'#'+IntToStr(ord(S[i]));
    end
    else
    begin
      if LoChars then
      begin
        R:=R+'''';
        LoChars:=false;
      end;
      if S[i]='''' then R:=R+'''';
      R:=R+S[i];
    end;
    inc(i);
  end;
  AddQuete:=''''+R+'''';
end;

function DelQuete(const S:string):string;
var R:string;
    i,j:integer;
    InString:boolean;
begin
  i:=1;
  R:='';
  InString:=false;
  while I<=Length(S) do
  begin
    if S[i]='''' then
      if InString then
        if i<Length(S) then
          if S[i+1]='''' then
          begin
            R:=R+S[i];
            inc(i);
          end
          else InString:=false
        else InString:=false
      else InString:=true
    else
    begin
      if (S[i]='#') and not InString then
      begin
        inc(i);
        j:=I;
        while (j<Length(S)) and (j<I+4) and (S[j] in Digit) do inc(j);
        if (J<>i) or (j>=Length(S)) or (S[j] in Digit) then
          R:=R+Char(StrToInt(Copy(S,i,j-i)) mod 256);
        i:=J-1;
      end
      else R:=R+S[i];
    end;
    inc(i);
  end;
  DelQuete:=R;
end;

function NameCase(S:string):string;
var I:integer;
procedure SkipBlank;
begin
  while (i<=Length(S)) and not (S[i] in WordChars) do inc(i);
end;
procedure SkipWord;
begin
  while (i<=Length(S)) and (S[i] in WordChars) do
  begin
    S[i]:=chLoCase(S[i]);
    inc(i);
  end;
end;
begin
  i:=1;
  while i<=Length(S) do
  begin
    SkipBlank;
    S[i]:=chUpCase(S[i]);
    inc(i);
    SkipWord;
  end;
  NameCase:=S;
end;


procedure MyCopyright;
const
  UniLib='UniLib (c) 1995,2001 by Alexs';
var aa:ShortString;
begin
  aa:=UniLib;
end;

begin
  MyCopyright;
end.
