unit Win32Ctrl_Macro;
{$H+}
interface
uses Windows;
type
  PColor = ^TColor;
  TColor = -$7FFFFFFF-1..$7FFFFFFF;

const
  clScrollBar = TColor(COLOR_SCROLLBAR or $80000000);
  clBackground = TColor(COLOR_BACKGROUND or $80000000);
  clActiveCaption = TColor(COLOR_ACTIVECAPTION or $80000000);
  clInactiveCaption = TColor(COLOR_INACTIVECAPTION or $80000000);
  clMenu = TColor(COLOR_MENU or $80000000);
  clWindow = TColor(COLOR_WINDOW or $80000000);
  clWindowFrame = TColor(COLOR_WINDOWFRAME or $80000000);
  clMenuText = TColor(COLOR_MENUTEXT or $80000000);
  clWindowText = TColor(COLOR_WINDOWTEXT or $80000000);
  clCaptionText = TColor(COLOR_CAPTIONTEXT or $80000000);
  clActiveBorder = TColor(COLOR_ACTIVEBORDER or $80000000);
  clInactiveBorder = TColor(COLOR_INACTIVEBORDER or $80000000);
  clAppWorkSpace = TColor(COLOR_APPWORKSPACE or $80000000);
  clHighlight = TColor(COLOR_HIGHLIGHT or $80000000);
  clHighlightText = TColor(COLOR_HIGHLIGHTTEXT or $80000000);
  clBtnFace = TColor(COLOR_BTNFACE or $80000000);
  clBtnShadow = TColor(COLOR_BTNSHADOW or $80000000);
  clGrayText = TColor(COLOR_GRAYTEXT or $80000000);
  clBtnText = TColor(COLOR_BTNTEXT or $80000000);
  clInactiveCaptionText = TColor(COLOR_INACTIVECAPTIONTEXT or $80000000);
  clBtnHighlight = TColor(COLOR_BTNHIGHLIGHT or $80000000);
  cl3DDkShadow = TColor(COLOR_3DDKSHADOW or $80000000);
  cl3DLight = TColor(COLOR_3DLIGHT or $80000000);
  clInfoText = TColor(COLOR_INFOTEXT or $80000000);
  clInfoBk = TColor(COLOR_INFOBK or $80000000);

  clBlack = TColor($000000);
  clMaroon = TColor($000080);
  clGreen = TColor($008000);
  clOlive = TColor($008080);
  clNavy = TColor($800000);
  clPurple = TColor($800080);
  clTeal = TColor($808000);
  clGray = TColor($808080);
  clSilver = TColor($C0C0C0);
  clRed = TColor($0000FF);
  clLime = TColor($00FF00);
  clYellow = TColor($00FFFF);
  clBlue = TColor($FF0000);
  clFuchsia = TColor($FF00FF);
  clAqua = TColor($FFFF00);
  clLtGray = TColor($C0C0C0);
  clDkGray = TColor($808080);
  clWhite = TColor($FFFFFF);
  clNone = TColor($1FFFFFFF);
  clDefault = TColor($20000000);

type
  TCriticalSection = TRTLCriticalSection;
  CRITICAL_SECTION = TRTLCriticalSection;

function ComboBox_AddString(hwndCtl:HWND; P:PChar):integer;inline;
begin
  Result:=SendMessage(hwndCtl, cb_AddString, 0, Integer(P));
end;

function ComboBox_GetLBText(hwndCtl:HWND; Index:integer; P:PChar):integer;inline;
begin
  Result:=Integer(SendMessage(hwndCtl, cb_GetLBText, Index, LongInt(P)));
end;

function ComboBox_SetCurSelect(hwndCtl:HWND; Index:integer):integer;inline;
begin
  Result:=Integer(SendMessage(hwndCtl, CB_SETCURSEL, Index, 0));
end;

function ComboBox_GetCurSelect(hwndCtl:HWND):integer;inline;
begin
  Result:=Integer(SendMessage(hwndCtl, CB_GETCURSEL, 0, 0));
end;

function Button_GetCheck(hwndCtl:HWND):boolean;inline;
begin
  Result:=SendMessage(hwndCtl, bm_GetCheck, 0, 0)=BST_CHECKED;
end;

function ListBox_GetCount(Handle:HWND):integer;inline;
begin
  Result:=SendMessage(Handle, LB_GETCOUNT, 0, 0);
end;

procedure ListBox_SetSelected(Handle:HWND; Index:integer);inline;
begin
  SendMessage(Handle, LB_SETCURSEL, Index, 0);
end;

function ListBox_GetSelected(Handle:HWND):integer;inline;
begin
  Result:=SendMessage(Handle, LB_GETCURSEL, 0, 0);
end;

function ListBox_AddString(Handle:HWND; AStr:PChar):integer;inline;
begin
  Result:=SendMessage(Handle, lb_AddString, 0, Integer(PChar(AStr)));
end;

function ListBox_DeleteString(Handle:HWND; Index:integer):integer;inline;
begin
  Result:=SendMessage(Handle, LB_DELETESTRING, 0, 0);
end;

function Control_SetText(Handle:HWND; AStr:PChar):integer;inline;
begin
  Result:=SendMessage(Handle, WM_SETTEXT, 0, Integer(PChar(AStr)));
end;

implementation

end.
